<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

// admin could be authenticated already
// allow password change from displayaccess form
if ($user and $HTTP_SERVER_VARS[AUTH_VAR] == ADMINUSER) {

}
else {
   $auth = new SQLAuthenticator(REALM, REALMERROR);

   // And now perform the authentication
   $auth->authenticate();
}

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Change user password");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "admin.php");

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

if ($HTTP_POST_VARS) {
   $password1=trim($password1);
   $password2=trim($password2);

   if (strlen($password1) < 5 or strlen($password2) < 5) {
      $formerror .= my_("The password entered must be at least five characters")."<br>";
   }
   if ($password1 != $password2) {
      $formerror .= my_("The passwords entered do not match")."<br>";
   }

   if (!$formerror) {
      if ($user)
         $userid=$user;
      else
         $userid=$HTTP_SERVER_VARS[AUTH_VAR];

      $password=crypt($password1, 'xq');

      $ds->DbfTransactionStart();
      $result=&$ds->ds->Execute("UPDATE users
                              SET password=".$ds->ds->qstr($password)."
                              WHERE userid=".$ds->ds->qstr($userid));
      $ds->AuditLog(sprintf(my_("User %s changed password"), $userid));

      if ($result) {
         $ds->DbfTransactionEnd();
         insert($w,text(my_("Password changed")));
      }
      else {
         $formerror .= my_("Password could not be changed")."<br>";
      }
   }
}

if (!$HTTP_POST_VARS || $formerror) {
   insert($w,text($formerror, array("color"=>"red")));

   // display opening text
   if ($user) {
      insert($w,textbr());
      insert($w,text(sprintf(my_("Change password for user %s"), $user)));
   }
   else {
      insert($w,textbr());
      insert($w,text(sprintf(my_("Change password for user %s"), $HTTP_SERVER_VARS[AUTH_VAR])));
   }

   // start form
   insert($w, $f = form(array("method"=>"post",
                              "action"=>$PHP_SELF)));

   if ($user) {
      insert($f,hidden(array("name"=>"user",
                             "value"=>"$user")));
   }

   insert($f,textbrbr(my_("New password (case sensitive!):")));
   insert($f,password(array("name"=>"password1",
                            "value"=>"$password1",
                            "size"=>"40",
                            "maxlength"=>"40")));

   insert($f,textbrbr(my_("New password (again):")));
   insert($f,password(array("name"=>"password2",
                            "value"=>"$password2",
                            "size"=>"40",
                            "maxlength"=>"40")));

   insert($f,generic("br"));
   insert($f,submit(array("value"=>my_("Submit"))));
   insert($f,freset(array("value"=>my_("Clear"))));
}

printhtml($w);

?>
