<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Create a new group");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "admin.php");

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

if ($HTTP_POST_VARS) {
   $grp=trim($grp);
   $grpdescrip=trim($grpdescrip);

   if (strlen($grp) < 2) {
      $formerror .= my_("The group name must be longer")."<br>";
   }
   if (strlen($grpdescrip) < 2) {
      $formerror .= my_("The group description must be longer")."<br>";
   }
   if (ereg("[^[:alnum:]-]", $grp)) {
      $formerror .= my_("Only numbers and digits are allowed in the group name")."<br>";
   }

   if (!$formerror) {
      $ds->DbfTransactionStart();

      // grpopt is a bit encoded field which will contain true/false type
      // options on groups - currently only one bit is used to define if
      // customers can view others data

      // bit 1 : 1 = user can view all customers info
      //         0 = user can view only groups customers
      $grpbit=0;
      if($grpview=="Y") {
         $grpbit=1;
      }

      $result=&$ds->ds->Execute("INSERT INTO grp
                                (grp, createcust, grpdescrip, grpopt)
                             VALUES
                                (".$ds->ds->qstr($grp).",
                                 ".$ds->ds->qstr($createcust).",
                                 ".$ds->ds->qstr($grpdescrip).",
                                 ".$grpbit.")");

      if ($result) {
         $ds->DbfTransactionEnd();
         insert($w,textbr(my_("Group created")));
      }
      else {
         $ds->DbfTransactionRollback();
         $formerror .= my_("Group could not be created - possibly a duplicate")."<br>";
      }
   }
}

insert($w,text($formerror, array("color"=>"red")));

// display opening text
insert($w,textbr());
insert($w,text($title));

// start form
insert($w, $f = form(array("method"=>"post",
                           "action"=>$PHP_SELF)));

insert($f,textbrbr(my_("Group name:")));
 
insert($f,input_text(array("name"=>"grp",
                           "value"=>"$grp",
                           "size"=>"40",
                           "maxlength"=>"40")));

insert($f,textbrbr(my_("Group description:")));
insert($f,input_text(array("name"=>"grpdescrip",
                           "value"=>"$grpdescrip",
                           "size"=>"80",
                           "maxlength"=>"80")));

insert($f,textbrbr(my_("Group can create/modify/delete customers?")));
insert($f,selectbox(array("N"=>my_("No"),
                          "Y"=>my_("Yes")),
                    array("name"=>"createcust")));

insert($f,textbrbr(my_("Group can view any customers data?")));
insert($f,selectbox(array("Y"=>my_("Yes"),
                          "N"=>my_("No")),
                    array("name"=>"grpview")));

insert($f,generic("br"));
insert($f,submit(array("value"=>my_("Submit"))));
insert($f,freset(array("value"=>my_("Clear"))));

printhtml($w);

?>
