<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");
require_once("../xmllib.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Import IP details result");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "admin.php");

// explicitly cast variables as security measure against SQL injection
$cust=floor($cust);
if (!$HTTP_POST_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

if (empty($HTTP_POST_FILES)) {
   $tmp=get_cfg_var("file_uploads");
   if (empty($tmp)) {
      insert($w,block("<b>".my_("File uploads may have been disabled in the php.ini configuration file")."</b><p>"));
   }
}
else {
   if ($HTTP_POST_FILES['userfile']['size'] == 0) {
      myError($w, my_("Possible file size exceeded php.ini or webserver limit of 2meg - break file into smaller parts"));
   }
   if (!is_uploaded_file($HTTP_POST_FILES['userfile']['tmp_name'])) {
      myError($w, my_("Possible file upload attack"));
   }
}
$filename = $HTTP_POST_FILES['userfile']['tmp_name'];

// basic sequence is connect, search, interpret search
// result, close connection

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

$rowcnt=0;
$ds->DbfTransactionStart();
if ($format=="xml") {
   // read entire file
   $input = implode("",file($filename));
   $xml_parser = new xml("HOST");
   if (!$xml_parser->parser) {
      myError($w, my_("XML not available"));
   }
   $output=$xml_parser->parse($input);
   if (!$output) {
      myError($w, my_("Data not in XML format"));
   }

   foreach ($output as $value) {
      $rowcnt++;
      insert($w,textbr());
      insert($w,text(my_("Importing record:")." $rowcnt "));
      if ($value["STATUS"]["STATE"]=="up") {
         $data[0]=$value["ADDRESS"]["ADDR"];
         if(empty($value["OSMATCH"]["NAME"])) {
            $data[1]="";
         }
         else {
            $data[1]=$value["OSMATCH"]["NAME"];
         }
         $data[2]="";
         $data[3]="active";
         if(empty($value["HOSTNAME"]["NAME"])) {
            $data[4]="";
         }
         else {
            $data[4]=$value["HOSTNAME"]["NAME"];
         }
         $data[5]="";
         ProcessRow($ds, $cust, $w, $data);
      }
   }
}
else {
   // open uploaded file for read
   $fp = @fopen ($filename, "r");
   // no real portable way to check if file was uploaded - php version
   // dependent
   if (!$fp) {
      myError($w, my_("File could not be opened."));
   }

   while ($data = fgetcsv ($fp, 1000, "\t")) {
      $rowcnt++;
      insert($w,textbr());
      insert($w,text(my_("Importing row:")." $rowcnt "));

      ProcessRow($ds, $cust, $w, $data);
   }
   fclose ($fp);
}
$ds->DbfTransactionEnd();

printhtml($w);


// $data is number indexed array that has format of ip, user, location, 
// description, telephone
function ProcessRow($ds, $cust, &$w, $data) {

   $num = count ($data);

   // blank row
   if (empty($data[0])) {
      insert($w,block("<b>".my_("Row is blank - ignoring")."</b>"));
      return;
   }
   // bogus row
   if ($num!=6) {
      // ok to save what has been imported already
      $ds->DbfTransactionEnd();
      myError($w, my_("Row not the correct format."));
   }

   if (testIP($data[0])) {
      insert($w,block("<b>".my_("Invalid IP address")."</b>"));
      return;
   }

   $ip=inet_aton($data[0]);
   $user=$data[1];
   $location=$data[2];
   $descrip=$data[3];
   $hname=$data[4];
   $telno=$data[5];

   // NOTE: Test ip address
   $result=$ds->GetBaseFromIP($ip, $cust);
   if (!$row = $result->FetchRow()) {
      // ok to save what has been imported already
      $ds->DbfTransactionEnd();
      myError($w, my_("Subnet could not be found"));
   }

   $baseindex=$row["baseindex"];
   $baseaddr=$row["baseaddr"];
   $subnetsize=$row["subnetsize"];

   // 8th parameter (action) is blank
   if ($ds->ModifyIP($ip, $baseindex, $user, $location, 
                $telno, $descrip, $hname, "") == 0) {
      insert($w,text(my_("IP address details modified")));
   }
   else
      insert($w,text(my_("IP address details could not be modified")));

}

?>
