<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Modify group details");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "admin.php");

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

if ($HTTP_POST_VARS) {
   $grpdescrip=trim($grpdescrip);

   if (strlen($grpdescrip) < 2) {
      $formerror .= my_("The group description must be longer")."<br>";
   }
 
   if (!$formerror) {

      $ds->DbfTransactionStart();

      // grpopt is a bit encoded field which will contain true/false type
      // options on groups - currently only one bit is used to define if
      // customers can view others data
      $grpbit=0;
      if($grpview=="Y") {
         $grpbit=1;
      }


      $result=&$ds->ds->Execute("UPDATE grp
                           SET grpdescrip=".$ds->ds->qstr($grpdescrip).",
                               createcust=".$ds->ds->qstr($createcust).",
                               grpopt=".$grpbit."
                           WHERE grp=".$ds->ds->qstr($grp));

      if ($result) {
         $ds->DbfTransactionEnd();
         insert($w,text(my_("Group details modified")));
      }
      else {
         $formerror .= my_("Group details could not be modified")."<br>";
      }
   }
}

if (!$HTTP_POST_VARS || $formerror) {
   insert($w,text($formerror, array("color"=>"red")));

   // display opening text
   insert($w,textbr());
   insert($w,text("$title."));

   // start form
   insert($w, $f = form(array("method"=>"post",
                              "action"=>$PHP_SELF)));

   insert($f,block("<br><b>"));
   insert($f,text(my_("Modify group: ")));
   insert($f,block("</b>"));
   insert($f,textbr($grp));
 
   insert($f,hidden(array("name"=>"grp",
                          "value"=>"$grp")));

   insert($f,textbrbr(my_("Group description:")));
   insert($f,input_text(array("name"=>"grpdescrip",
                              "value"=>"$grpdescrip",
                              "size"=>"80",
                              "maxlength"=>"80")));

   insert($f,textbrbr(my_("Group can create/modify/delete customers?")));
   insert($f,selectbox(array("N"=>my_("No"),
                             "Y"=>my_("Yes")),
                       array("name"=>"createcust"),
                       $createcust));

   insert($f,textbrbr(my_("Group can view any customers data?")));
   // first bit defines view capability
   insert($f,selectbox(array("N"=>my_("No"),
                             "Y"=>my_("Yes")),
                       array("name"=>"grpview"),
                       $grpopt & 1 ? "Y" : "N" ));


   insert($f,generic("br"));
   insert($f,submit(array("value"=>my_("Submit"))));
   insert($f,freset(array("value"=>my_("Clear"))));
}

printhtml($w);

?>
