<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// NOTE: DO NOT REMOVE ANY LINES FROM THIS FILE

// define some global variables for database connections
// currently mysql and postgres7 are valid database types.
// maxsql should be used for mysql with transactions.
// oci8po is valid for oracle 9i (older versions of oracle
// are not supported). sybase, ado_mssql and mssql may work too.
// odbc_mssql should work for windows systems using IIS and mssql
// look in the adodb/drivers directory for additional drivers.

// the database user and password is NOT the same user and password
// used to access IPplan as a user.
define("DBF_TYPE", "mysql");
define("DBF_HOST", "localhost");
define("DBF_USER", "ipplan");
define("DBF_NAME", "ipplan");
define("DBF_PASSWORD", "ipplan99");
// enable if using transaction safe tables. should be TRUE for all 
// databases except when using mysql with MyISAM tables
define("DBF_TRANSACTIONS", FALSE);
// use persistent database connections - not recommended for mysql
define("DBF_PERSISTENT", FALSE);
// turn on database debugging
define("DBF_DEBUG", FALSE);

// define some global variables for authentication
define("REALM", "IPplan authentication");
define("REALMERROR", "You need to enter a valid user-id and password");

// define global admin user and passwd. This is NOT the same user
// and password that the databases use.
define("ADMINUSER", "admin");
define("ADMINPASSWD", "admin");
define("ADMINREALM", "IPplan admin authentication");

// allow anonymous read access to information? If TRUE, anybody
// can view information, but authentication is required for all
// changes. Depending on your security policy, setting this to
// TRUE can be dangerous
define("ANONYMOUS", FALSE);

// setting to true logs all changes to the AuditLog
define("AUDIT", TRUE);

// maximum number of lines per table
// don't make this too large else you will get URI too large errors
define("MAXTABLESIZE", 128);

// maximum number of bytes allowed to upload via import functions,
// info fields and attached files
// don't make this too large - consider the disk space as the info
// is stored in your database
// WARNING: this setting will be ignored if it is bigger than specified
// in the php.ini file
// 524288 is the default for Apache - you will get "Document contains
// no data" errors if the Apache limit is exceeded as Apache just
// kills the connection when the upload size is exceeded
define("MAXUPLOADSIZE", 524288);

// repository for files uploaded. this directory should not be
// under the web tree and should be readable and writable by the
// web server - usually user apache and group apache
// see either httpd.conf User directive or ps -ef to see which user
// apache runs under, then set mode 700 on directory and change owner
// to this user
define("UPLOADDIRECTORY", "/var/spool/ipplanuploads");

// default country code ("" for none)
define("DEFAULTCOUNTRY", "US");

// default state code ("" for none)
define("DEFAULTSTATE", "FL");

// path to nmap scanner (http://www.insecure.org) - leave blank 
// to turn off scanning or if scanner is not available. this will
// not work if php is running in safemode. probing and scanning may 
// also be against policy for your site!
//define("NMAP", "");
define("NMAP", "/usr/local/bin/nmap");

//-------------------------START OF REGISTRAR---------------------------

// enable and disable SWIP/resgistrar functionality (only useful if 
// dealing with ARIN or any other registrar directly)
// valid entries are TRUE or FALSE
define("SWIPENABLED", TRUE);

// your network maintainer id used when sending SWIP/registrar updates
define("MAINTAINERID", "DefaultID");

// e-mail address to send swip/registrar entries to
define("SWIPEMAIL", "swip@registrar.net");

// your SWIP/registrar admins e-mail address
define("SWIPADMINEMAIL", "myemail@mydomain.com");

//-------------------------START OF DNS---------------------------------

// enable and disable DNS - valid entries are TRUE or FALSE
define("DNSENABLED", TRUE);

// DNS SOA information in seconds
define("DNSTTL", "21600");        // 6h
define("DNSREFRESH", "86400");    // 1d
define("DNSRETRY", "3600");       // 1h
define("DNSEXPIRE", "604800");    // 1w
define("DNSMINTTL", "21600");     // 6h

define("DNSSERVER1", "ns1.example.com");
define("DNSSERVER2", "ns2.example.com");
define("DNSSERVER3", "ns3.example.com");
define("DNSSERVER4", "ns4.example.com");

// export path where zone files in XML format will be output ready for
// transformation into zone file for various DNS servers
// NOTE: make sure that the webserver can write into this directory
//   this will usually be the user under which Apache runs. If the 
// permissions are not correct, the files will be created in the
// system temp directory, usually /tmp
define("DNSEXPORTPATH", "/tmp/ipplan-dns/");
//-------------------------START OF LANGUAGES---------------------------

// which languages are supported by ipplan - see TRANSLATIONS to 
// translate ipplan into your own language. NOTE: English must always
// be in the list and first
$iso_codes = array (
    'en_EN'=>'English',
    'fr_FR'=>'French - Auto Translation',
    'de_DE'=>'German - Auto Translation',
    'it_IT'=>'Italian - Auto Translation',
    'no_NO'=>'Norwegian - Auto Translation',
    'pt_PT'=>'Portuguese - Auto Translation',
    'es_ES'=>'Spanish - Auto Translation');

// should language choices be displayed?
define("LANGCHOICE", TRUE);

//-------------------------START OF AUTHENTICATION----------------------

// settings to alter methods of authentication - either using ipplans
// own internal authentication or your own external authentication
// NOTE: don't mess with these settings if you are not sure what you
// are doing

// associative array index which contains current authenticated user
// from $HTTP_SERVER_VARS
define("AUTH_VAR", "PHP_AUTH_USER");

// type of authentication, either internal or external
define("AUTH_INTERNAL", TRUE);

// show logout button - this is not secure, so turned off by default
// best method to logoff is to close all browser instances
// useful for testing
define("AUTH_LOGOUT", FALSE);

?>
