<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("ipplanlib.php");
require_once("config.php");

$lang=$HTTP_POST_VARS['lang'];

// set language cookie if language changed by user
// language includes path of ipplan root seperated by :
if ($lang) {
   setcookie("ipplanLanguage",$lang.":".dirname(__FILE__),time() + 10000000, "/");
   $HTTP_COOKIE_VARS['ipplanLanguage']=$lang.":".dirname(__FILE__);
}

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
                      "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <title>
<?php echo my_("IPplan - IP address management and tracking"); ?>
  </title>
</head>

<body bgcolor="#FFFFFF">

<?php
// only show language box if gettext is supported in php
if(extension_loaded("gettext")) {
   echo '<form NAME="THISFORM" METHOD="post" ACTION="index.php">';
}
?>
<table border="0" cellspacing="0" width="100%">
  <tbody>
    <tr valign=bottom>
      <td colspan="2" bgcolor="#99CCFF">
        <center>
        <h2>
<?php echo my_("IPplan - IP address management and tracking"); ?>
        </h2>
        </center>
      </td>
    </tr>
<?php
    echo '<tr valign=bottom>';
    echo '  <td bgcolor="#99CCFF" VALIGN="bottom">';
    echo '    <a HREF="http://iptrack.sourceforge.net">IPplan Home</a> | ';
    if (AUTH_LOGOUT==TRUE) {
        echo '    <a HREF="user/logout.php">Logout</a> | ';
    }
    echo '    <a HREF="http://sourceforge.net/forum/?group_id=32122">Help</a>';
    echo '  </td>';
    echo '  <td align=right bgcolor="#99CCFF">';
   if(extension_loaded("gettext") and LANGCHOICE) {
      echo 'Language:';
      echo '<select NAME="lang" ONCHANGE="submit()">';
      foreach($iso_codes as $key => $value)
         // look only at language part of cookie
         if (substr($HTTP_COOKIE_VARS['ipplanLanguage'],0,5)==$key)
            echo '<option VALUE="'.$key.'" SELECTED>'.$value."\n";
         else
            echo '<option VALUE="'.$key.'">'.$value."\n";
      echo '</select>';
   }
   echo '   </td>';
   echo '</tr>';
?>
  </tbody>
</table>
<?php
if(extension_loaded("gettext")) {
   echo '</form>';
}
?>

<script type="text/javascript">
</script>
<noscript>
<font size=4 color="#FF0000">
<p><b>
<?php echo my_("Your browser must be JavaScript capable to use this application. Please turn JavaScript on."); ?>
</b>
</font>
</noscript>

<?php

// test schema version and apply latest schema if needed
// requires full database access (at least alter table and create)
require_once("schema.php");

CheckSchema();

?>

<p>
<?php echo my_("This application administers and tracks IP address space."); ?>
</p>

<blockquote>
  <ul>
    <li><a href="admin/admin.php"><?php echo my_("IPplan admin functions"); ?></a></li>
  </ul>
</blockquote>


<?php echo my_("Customer/autonomous system group functions"); ?>

<blockquote>
  <ul>
    <li><a href="user/modifycustomer.php"><?php echo my_("Create a new customer/autonomous system"); ?></a></li>
    <li><a href="user/displaycustomerform.php"><?php echo my_("Display/Modify/Delete customer information/autonomous system"); ?></a></li>
    <li><a href="user/createarea.php"><?php echo my_("Create a new network area"); ?></a></li>
    <li><a href="user/createrange.php"><?php echo my_("Create a new network range or supernet"); ?></a></li>
    <li><a href="user/modifyarearangeform.php"><?php echo my_("Display/Modify/Delete area and range information"); ?></a></li>
    <li><a href="user/createsubnetform.php"><?php echo my_("Create a new subnet"); ?></a></li>
    <li><a href="user/displayrouterform.php"><?php echo my_("Create a new subnet from a routing table"); ?></a></li>
    <li><a href="user/modifybaseform.php"><?php echo my_("Modify/Copy/Move/Delete subnet information"); ?></a></li>
<?php
if (DNSENABLED) {
   echo '<p><li><a href="user/modifydns.php">';
   echo my_("Add/Edit/Delete/Export Zone Domains");
   echo '</a></li>';
   echo '<li><a href="user/modifydnsrecord.php">';
   echo my_("Add/Edit/Delete Zone DNS Records");
   echo '</a></li>';
   echo '<li><a href="user/modifyzone.php">';
   echo my_("Add/Edit/Modify Reverse Zones");
   echo '</a></li>';
}
?>
  </ul>
</blockquote>


<?php echo my_("User group functions"); ?>

<blockquote>
  <ul>
    <li><a href="user/displaybaseform.php"><?php echo my_("Display subnet information"); ?></a></li>
<?php
if (SWIPENABLED) {
   echo '<li><a href="user/displayswipform.php">';
   echo my_("Display SWIP/registrar information");
   echo '</a></li>';
}
?>
    <li><a href="user/searchallform.php"><?php echo my_("Search all subnets"); ?></a></li>
    <li><a href="user/findfreeform.php"><?php echo my_("Find free address space/Statistics"); ?></a></li>
    <li><a href="user/displayoverlapform.php"><?php echo my_("Display subnets that overlap between customers/autonomous systems"); ?></a></li>
  </ul>
</blockquote>

<?php echo my_("IPplan v4.04"); ?>

</body>
</html>
