<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

define("DEFAULTROUTE", "0.0.0.0");
define("ALLNETS", "255.255.255.255");


/*********** start of global code which runs for each script *********/

// compress output of all pages - could break things!
// breaks if there is space after last php close tag in script!
// must flush with ob_flush if sending from system() call
if (phpversion() >= "4.0.4") ob_start("ob_gzhandler");

// hack to make sure systems with register_globals off work
// very ugly, but it works. cannot be in function else variables
// must be declared global. will be called for each script as 
// this lib is always executed.
$types_to_register = array('GET','POST','COOKIE','SESSION','SERVER');
foreach ($types_to_register as $type) {
    $arr = @${'HTTP_' . $type . '_VARS'}; 
    // get rid of magic_quotes else get multiple quotes on each submit
    if (($type=="GET" or $type=="POST") and get_magic_quotes_gpc())  {
        $arr=stripslashes_deep($arr);
        // print_r(array_keys($arr));
    }
    if (@count($arr) > 0) {
        extract($arr, EXTR_OVERWRITE);
    }
}

// set the error reporting level for IPplan
error_reporting(E_ALL ^ E_NOTICE);
// set to the user defined error handler
set_error_handler("myErrorHandler");


/*********** end of global code which runs for each script *********/


// baseaddr is an int, not an ip address
// Test base address to see if it is on valid subnet boundary
function TestBaseAddr($baseaddr, $subnetsize) {

    $newsize = $subnetsize-1;
    return ($baseaddr & $newsize);

}

// scan a single host to see if it is up
function ScanHost($host, $timeout=2) {

   // try port 80, if we connect OK, else if error 111, also OK
   $fp = @fsockopen ($host, 80, $errno, $errstr, $timeout);
   if (!$fp) {
     // linux likes code 111, solaris likes 146
     if ($errno == 111 or $errno == 146) // connection refused
        return 1;
     else
        return 0;
   } else {
     return 1;
     fclose ($fp);
   }
}

// test for ip addresses between 1.0.0.0 and 255.255.255.255
function testIP($a, $allowzero=FALSE) {
    $t = explode(".", $a);

    if (sizeof($t) != 4)
       return 1;

    for ($i = 0; $i < 4; $i++) {
        // first octet may not be 0
        if ($t[0] == 0 && $allowzero == FALSE)
           return 1;
        if ($t[$i] < 0 or $t[$i] > 255)
           return 1;
        if (!is_numeric($t[$i]))
           return 1;
    };
    return 0;
}

// fill subnet - add 0 or 255 as required
// options - 1 for 0, 2 for 255
function completeIP($a, $opt) {

    $t = explode(".", $a);
    for ($i = 4; $i > sizeof($t); $i--) {
        if ($opt == 1)
           $a = $a.".0";
        else
           $a = $a.".255";
    }

    return $a;
}

// php function ip2long is broken!!! (mod_php4.0.4p1)
function inet_aton($a) {
    $inet = 0.0;
    $t = explode(".", $a);
    for ($i = 0; $i < 4; $i++) {
        $inet *= 256.0;
        $inet += $t[$i];
    };
    return $inet;
}

// php function ip2long is broken!!! (mod_php4.0.4p1)
function inet_aton3($a) {
    $inet = 0.0;
    $t = explode(".", $a);
    for ($i = 1; $i < 4; $i++) {
        $inet *= 256.0;
        $inet += $t[$i];
    };
    return $inet;
}

// php function long2ip is broken!!! (mod_php4.0.4p1)
function inet_ntoa($n) {
    $t=array(0,0,0,0);
    $msk = 16777216.0;
    $n += 0.0;
    if ($n < 1)
        return('&nbsp;');
    for ($i = 0; $i < 4; $i++) {
        $k = (int) ($n / $msk);
        $n -= $msk * $k;
        $t[$i]= $k;
        $msk /=256.0;
    };
    $a=join('.', $t);
    return($a);
}

// returns the number of bits in the mask cisco style
function inet_bits($n) {

    if ($n == 1)
       return 32;
    else
       return 32-strlen(decbin($n-1));
}

// display various blocks of subnet
function DisplayBlock($w, $row, $totcnt, $anchor) {

       global $PHP_SELF;

       $cnt=intval($totcnt/MAXTABLESIZE);
       $vars=$PHP_SELF."?block=".$cnt.$anchor;
       if ($totcnt % MAXTABLESIZE == 0) {
          insert($w,anchor($vars, inet_ntoa($row["baseaddr"])));
       }
       if ($totcnt % MAXTABLESIZE == MAXTABLESIZE-1) {
          insert($w,text(" - "));
          insert($w,anchor($vars, inet_ntoa($row["baseaddr"])));
          insert($w,textbr());
       }
       
       return $vars;
}

// displays customer drop down box - requires a working form
// $submit parameter allows drop down to just be displayed, normal
// behaviour will be to submit to self
function myCustomerDropDown($ds, $f1, $cust, $grps, $submit=TRUE) {

   // need to see cookie!
   global $ipplanCustomer, $displayall;

   $custset=0;

   $cust=floor($cust);   // dont trust $cust as it could 
                         // come from form post
   // display customer drop down list, nothing to display, just exit
   if (!$result=$ds->GetCustomerGrp(0))
       return 0;

   // do this here else will do extra queries for every customer
   $adminuser=$ds->TestGrpsAdmin($grps);

   insert($f1,textbrbr(my_("Customer/autonomous system")));
   $lst=array();
   while($row=$result->FetchRow()) {
      // ugly kludge with global variable!
      // remove all from list if global searching is not available
      if (!$displayall and strtolower($row["custdescrip"])=="all")
         continue;

      // strip out customers user may not see due to not being member
      // of customers admin group. $grps array could be empty if anonymous
      // access is allowed!
      if(!$adminuser) {
         if(!empty($grps)) {
            if(!in_array($row["admingrp"], $grps))
               continue;
         }
      }

      $col=$row["customer"];
      // make customer first customer in database
      if (!$cust) {
         $cust=$col;
         $custset=1;    // remember that customer was blank
      }
      // only make customer same as cookie if customer actually
      // still exists in database, else will cause loop!
      if ($custset) {
         if ($col == $ipplanCustomer)
            $cust=$ipplanCustomer;
      }
      $lst["$col"]=$row["custdescrip"];
   }

   if ($submit)
      insert($f1,selectbox($lst,
                        array("name"=>"cust", "onChange"=>"submit()"),
                        $cust));
   else
      insert($f1,selectbox($lst,
                        array("name"=>"cust"),
                        $cust));

   return $cust;

}

// displays area drop down box - requires a working form
// does not matter if areaindex is out of range, will pick "No range"
function myAreaDropDown($ds, $f1, $cust, $areaindex) {

   $cust=floor($cust);   // dont trust $cust as it could 
                         // come from form post
   $areaindex=floor($areaindex);

   // display area drop down list
   $result=$ds->GetArea($cust, 0);

   // don't bother if there are no records, will always display "No area"
   insert($f1,textbrbr(my_("Area (optional)")));
   $lst=array();
   $lst["0"]=my_("No area selected");
   while($result and $row = $result->FetchRow()) {
      $col=$row["areaindex"];
      $lst["$col"]=inet_ntoa($row["areaaddr"])." - ".$row["descrip"];
   }

   insert($f1,selectbox($lst,
                     array("name"=>"areaindex","onChange"=>"submit()"),
                     $areaindex));

   return $areaindex;

}

// displays range drop down box - requires a working form
function myRangeDropDown($ds, $f2, $cust, $areaindex) {

   $cust=floor($cust);   // dont trust $cust as it could 
                         // come from form post
   $areaindex=floor($areaindex);

   // display range drop down list
   if ($areaindex)
      $result=$ds->GetRangeInArea($cust, $areaindex);
   else
      $result=$ds->GetRange($cust, 0);

   // don't bother if there are no records, will always display "No range"
   insert($f2,textbrbr(my_("Range (optional)")));
   $lst=array();
   $lst["0"]=my_("No range selected");
   while($row = $result->FetchRow()) {
      $col=$row["rangeindex"];
      $lst["$col"]=inet_ntoa($row["rangeaddr"])."/".inet_ntoa(inet_aton(ALLNETS)-$row["rangesize"]+1).
                   "/".inet_bits($row["rangesize"])." - ".$row["descrip"];
   }

   insert($f2,selectbox($lst,
                     array("name"=>"rangeindex")));

}

// displays error messages and terminates the programs execution
// should only be used for terminal errors that cannot recover (database etc)
// will also ignore previous output generated for the HTML page
function myError($w, $message) {

   // display error message
   insert($w,text($message, array("color"=>"red")));

   printhtml($w);
   exit;

}

// wrapper around gettext function to check if gettext is available first
// gettext is used to internationalize a program
// see http://www.gnu.org/software/gettext
//     http://zez.org/article/articleview/42/
//     http://www.php-er.com/chapters/Gettext_Functions.html
function my_($message) {

   return extension_loaded("gettext") ? gettext($message) : $message;

}

// set the language to use
// cookie is in form <2 letter country code>;<path to ipplan root>
function myLanguage($langcookie) {

   if(extension_loaded("gettext")) {
      // split language and path from cookie
      list($lang,$path) = explode(":", $langcookie, 2);

      // Set language environment variable
      // not required anymore
      //putenv("LANG=$lang");
      setlocale(LC_ALL, $lang);
                                                                                
      // Specify location of translation tables 
      bindtextdomain ("messages", $path."/locale"); 

      // Choose domain 
      textdomain ("messages");
   }
}

// draw title block
function myheading($w, $title, $anchor, $quickmenu=false) {

    if ($quickmenu) {
        insert($w,block('
<SCRIPT LANGUAGE="JavaScript">
<!--
   function jump(sel) { // jump to listbox selection
      var url = sel.options[sel.selectedIndex].value;
      if(url) {
         window.location = url;}}
// --> 
</script>
'));
    }

    insert($w, $f = form(array("name"=>"menu1")));
    insert($f,$t = table(array("cols"=>"2",
                               "border"=>"0",
                               "cellspacing"=>"0",
                               "width"=>"100%")));
    insert($t,$c = cell(array("colspan"=>"2",
                              "bgcolor"=>"#99CCFF")));
    insert($c,block("<center><h2>"));
    insert($c,text($title));
    insert($c,block("</h2></center>"));
    insert($t,$c = cell(array("bgcolor"=>"#99CCFF", 
                              "valign"=>"bottom")));
    insert($c,anchor($anchor, my_("Home")));

    if ($quickmenu) {
       $lst["0"]=my_("Quick Menu");
       $lst["modifycustomer.php"]=my_("Create a new customer/autonomous system");
       $lst["displaycustomerform.php"]=my_("Display/Modify/Delete customer information/autonomous system");
       $lst["createarea.php"]=my_("Create a new network area");
       $lst["createrange.php"]=my_("Create a new network range or supernet");
       $lst["modifyarearangeform.php"]=my_("Display/Modify/Delete area and range information");
       $lst["createsubnetform.php"]=my_("Create a new subnet");
       $lst["displayrouterform.php"]=my_("Create a new subnet from a routing table");
       $lst["modifybaseform.php"]= my_("Modify/Copy/Move/Delete subnet information");
       $lst["displaybaseform.php"]=my_("Display subnet information");
       $lst["searchallform.php"]=my_("Search all subnets");
       $lst["findfreeform.php"]=my_("Find free address space/Statistics");
       $lst["displayoverlapform.php"]=my_("Display subnets that overlap between customers/autonomous systems");

       insert($t,$c = cell(array("align"=>"right", 
                                 "valign"=>"bottom",
                                 "bgcolor"=>"#99CCFF")));

       insert($c,selectbox($lst,
                        array("name"=>"dest1","onChange"=>"jump(this.form.dest1)")));
    }

}

// IPplan error handler function
function myErrorHandler ($errno, $errstr, $errfile, $errline) {

   // check what we actually want to report on, ignore rest
   if (!($errno & error_reporting())) return;

   switch ($errno) {
       case E_USER_ERROR:
           echo "<b>FATAL</b> [$errno] $errstr<br>\n";
           echo "  Fatal error in line ".$errline." of file ".$errfile;
           echo ", PHP ".PHP_VERSION." (".PHP_OS.")<br>\n";
           echo "Aborting...<br>\n";
           exit;
           break;
       case E_USER_WARNING:
           echo "<b>ERROR</b> [$errno] $errstr Line: $errline File: $errfile<br>\n";
           break;
       case E_USER_NOTICE:
           echo "<b>WARNING</b> [$errno] $errstr Line: $errline File: $errfile<br>\n";
           break;
       case E_NOTICE:
           echo "<b>NOTICE</b> [$errno] $errstr Line: $errline File: $errfile<br>\n";
           break;
       default:
           echo "Unkown error type: [$errno] $errstr<br>\n";
           break;
   }
}

function color_flip_flop() {
    // Added by Stephen Blackstone
    // Simple Function to alternate the two pieces by color.

    $color1="#F1F1F1";   // Define row color A.
    $color2="#FFFFFF"; 	 // Define row color B.
    static $currentcolor;
    if ($currentcolor==$color1) { 
        $currentcolor=$color2; 
    }
    else {
        $currentcolor=$color1; 
    }

    return($currentcolor);

}

function stripslashes_deep($value) {
    $value = is_array($value) ?
        array_map('stripslashes_deep', $value) :
            stripslashes($value);

    return $value;
}



?>
