<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

if (!ANONYMOUS) {
   $auth = new SQLAuthenticator(REALM, REALMERROR);

   // And now perform the authentication
   $grps=$auth->authenticate();
}

// save the last customer used
// must set path else Netscape gets confused!
setcookie("ipplanCustomer","$cust",time() + 10000000, "/");

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Results of your search");
newhtml($w);

insert($w, $h=wheader($title));
myheading($w, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
$cust=floor($cust);
$areaindex=floor($areaindex);
$rangeindex=floor($rangeindex);
$searchin=(int)$searchin;
if (!$HTTP_GET_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection
$ds = new Base() or myError($w, my_("Could not connect to database"));

$ds->SetGrps($grps);
$ds->SetIPaddr($ipaddr);
$ds->SetSearchIn($searchin);
$ds->SetDescrip($descrip);

$result = $ds->FetchBase($cust, $areaindex, $rangeindex);
if (!$result) {
   myError($w, $ds->errstr);
}

// for "all" customer, $cust may have changed in class
$cust=$ds->cust;

if ($areaindex and !$rangeindex) {
   insert($w,heading(3, sprintf(my_("Search for IP subnets between multiple ranges for customer '%s'"), $ds->custdescrip)));
}
else {
   insert($w,heading(3, sprintf(my_("Search for IP subnets between %s and %s %s for customer '%s'"), $ds->start, $ds->end, $ds->site, $ds->custdescrip)));
}

if ($ipaddr) {
   insert($w,textb(my_("IP address filter: ")));
   insert($w,textbr($ipaddr));
}
if ($descrip) {
   insert($w,textb(my_("Description filter: ")));
   insert($w,textbr($descrip));
}

$totcnt=0;
$vars="";
// fastforward till first record if not first block of data
while ($block and $totcnt < $block*MAXTABLESIZE and
       $row = $result->FetchRow()) {
    $vars=DisplayBlock($w, $row, $totcnt, 
                        "&cust=".$cust."&areaindex=".$areaindex.
                        "&rangeindex=".$rangeindex."&ipaddr=".$ipaddr.
                        "&descrip=".$descrip);
    $totcnt++;
}
insert($w,block("<p>"));

// create a table
insert($w,$tbig = table(array("cols"=>"1", "bgcolor"=>"#00CCFF")));
insert($tbig,$c = cell());
if (SWIPENABLED) {
   insert($c,$t = table(array("cols"=>"7",
                              "cellspacing"=>"1",
                              "bgcolor"=>"#99CCFF")));
}
else {
   insert($c,$t = table(array("cols"=>"6",
                              "cellspacing"=>"1",
                              "bgcolor"=>"#99CCFF")));
}

// draw heading
insert($t,$c = cell());
if (!empty($vars))
    insert($c,anchor($vars, "<<"));
insert($c,textb(my_("Base address")));
insert($t,$c = cell());
insert($c,textb(my_("Subnet size")));
insert($t,$c = cell());
insert($c,textb(my_("Subnet mask")));
insert($t,$c = cell());
insert($c,textb(my_("Description")));
insert($t,$c = cell());
insert($c,textb(my_("Last modified")));
insert($t,$ck = cell());
insert($ck,textb(my_("Changed by")));
if (SWIPENABLED) {
   insert($t,$ck = cell());
   insert($ck,textb(my_("SWIP sent")));
}


$cnt=0;
$prevrow="";
while($row = $result->FetchRow()) {
setdefault("cell",array("bgcolor"=>color_flip_flop()));

    // customer is 0, display all customers with customer description
    // on customer change
    if ($cust == 0 and $row["custdescrip"] != $prevrow) {
        if (SWIPENABLED) {
           insert($t,$c = cell(array("colspan"=>"7")));
        }
        else {
           insert($t,$c = cell(array("colspan"=>"6")));
        }

        insert($c,generic("b"));
        insert($c,anchor($PHP_SELF."?cust=".$row["customer"]."&areaindex=&rangeindex=&ipaddr=$ipaddr&descrip=$descrip", 
                         $row["custdescrip"]));
        $prevrow=$row["custdescrip"];
    }

    insert($t,$c = cell());
    insert($c,anchor("displaysubnet.php?baseindex=".$row["baseindex"], 
                     inet_ntoa($row["baseaddr"])));

    if ($row["subnetsize"] == 1) {
        insert($t,$c = cell());
        insert($c,text(my_("Host")));
    }
    else {
        insert($t,$c = cell());
        insert($c,text($row["subnetsize"]));
    }

    insert($t,$c = cell());
    insert($c,text(inet_ntoa(inet_aton(ALLNETS)+1 -
                    $row["subnetsize"])."/".inet_bits($row["subnetsize"])));

    insert($t,$c = cell());
    insert($c,text($row["descrip"]));
    insert($t,$c = cell());
    insert($c,block("<small>"));
    insert($c,block($result->UserTimeStamp($row["lastmod"], "M d Y H:i:s")));
    insert($c,block("</small>"));
    insert($t,$c = cell());
    insert($c,text($row["userid"]));
    if (SWIPENABLED) {
       insert($t,$c = cell());
       insert($c,block("<small>"));
       insert($c,block($result->UserTimeStamp($row["swipmod"], "M d Y H:i:s")));
       insert($c,block("</small>"));
    }

    if ($totcnt % MAXTABLESIZE == MAXTABLESIZE-1)
       break;
    $cnt++;
    $totcnt++;
}
insert($w,block("<p>"));

if (!$cnt) {
   myError($w, my_("Search found no matching entries"));
}

$vars="";
$printed=0;
while ($row = $result->FetchRow()) {
    $totcnt++;
    $vars=DisplayBlock($w, $row, $totcnt, 
                        "&cust=".$cust."&areaindex=".$areaindex.
                        "&rangeindex=".$rangeindex."&ipaddr=".$ipaddr.
                        "&descrip=".$descrip);
    if (!empty($vars) and !$printed) {
        insert($ck,anchor($vars, ">>"));
        $printed=1;
    }
}

$result->Close();
printhtml($w);

?>
