<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
//include('../adodb/adodb-errorhandler.inc.php');
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

require_once("../class.templib.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Results of your search");
newhtml($w);

insert($w, $h=wheader($title));
//insert($h, block('<link rel="StyleSheet"  href="../styles/test3.css" type="text/css" />'));

myheading($w, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
$baseindex=floor($baseindex);
if (is_array($ip)) {
    foreach($ip as $key => $value) {
        $ip[$key]=floor($value);
    }
}
else {
   $ip=floor($ip);
}
$block=(int)$block;
$showactive=(int)$showactive;
$showdns=(int)$showdns;
$action=(string)$action;
if (!$HTTP_GET_VARS and !$HTTP_POST_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

$ds=new IPplanDbf() or myError($w, "Could not connect to database");

// script gets called back from modifyipform script so that user does
// not need to press back button
if ($HTTP_POST_VARS) {
    if ($grp=$ds->GetBaseGrp($baseindex)) {
        if (in_array($grp, $grps) or 
                $ds->TestCustomerGrp($baseindex, $HTTP_SERVER_VARS[AUTH_VAR])) {

            if ($md5str!=$ds->GetMD5($ip, $baseindex))
                myError($w,my_("Another user modified the information before you saved - restart")."<br>");

            $ds->DbfTransactionStart();

            // additional information will arrive as assoc array called template
            // this is serialized into the info blob field of the database

            // need to start class and verify data before inserting

            if ($action=="delete") {

                // bad code - needs cleanup
                if (is_array($ip)) {
                    foreach($ip as $iptemp) {
                        // remove all attached files
                        $result=&$ds->ds->Execute("SELECT infobin
                                FROM ipaddradd
                                WHERE ipaddr=$iptemp AND baseindex=$baseindex");

                        $rowadd = $result->FetchRow();
                        $files=unserialize($rowadd["infobin"]);
                        // if dbf field is empty, unserialize returns FALSE
                        if ($files!=FALSE) {
                            foreach($files as $key => $value) {
                                @unlink(UPLOADDIRECTORY."/".($files[$key]["tmp_name"]));
                            }
                        }
                        $ds->DeleteIP($iptemp, $baseindex);
                        $ds->AuditLog(sprintf
                         (my_("User %s deleted ip details %s index %u"),
                          $HTTP_SERVER_VARS[AUTH_VAR], inet_ntoa($iptemp),
                          $baseindex));

                    }
                }
                else {
                    // remove all attached files
                    $result=&$ds->ds->Execute("SELECT infobin
                            FROM ipaddradd
                            WHERE ipaddr=$ip AND baseindex=$baseindex");

                    $rowadd = $result->FetchRow();
                    $files=unserialize($rowadd["infobin"]);
                    // if dbf field is empty, unserialize returns FALSE
                    if ($files!=FALSE) {
                        foreach($files as $key => $value) {
                            @unlink(UPLOADDIRECTORY."/".($files[$key]["tmp_name"]));
                        }
                    }
                    $ds->DeleteIP($ip, $baseindex);
                    $ds->AuditLog(sprintf
                         (my_("User %s deleted ip details %s index %u"),
                          $HTTP_SERVER_VARS[AUTH_VAR], inet_ntoa($ip),
                          $baseindex));

                }

                $ds->DbfTransactionEnd();
                insert($w,text(my_("IP address records deleted")));

            }
            else {
                $err=FALSE;
                // if a specific network template exists, use that, else use generic template
                if (is_readable(dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME'])."/iptemplate-network.xml") and !TestBaseAddr($ip, $subnetsize)) {
                    $template=new IPplanIPTemplate(dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME'])."/iptemplate-network.xml");
                }
                else {
                    $template=new IPplanIPTemplate(dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME'])."/iptemplate.xml");
                }
                // info field passed to ModifyIP must be "" if record is
                // to be deleted from ipaddradd table automatically to
                // conserve space - NB!
                $info="";
                if ($template->is_error() == FALSE) {
                    // PROBLEM HERE: if template create suddenly returns error (template file
                    // permissions, xml error etc), then each submit thereafter will erase
                    // previous contents - this is not good
                    $template->Merge($userfld);
                    $err=$template->Verify($w);

                    if ($template->is_blank() == FALSE) {
                        $info=$template->encode();
                    }
                }

                // verify template and insert data into tables - only insert if
                // template verifies ok
                if (!empty($hname)) {
                    if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?$/', $hname)) {

                        insert($w,text(sprintf(my_("Invalid hostname: %s %s"), inet_ntoa($ip), 
                                        $hname),
                                    array("color"=>"#FF0000")));
                        insert($w,textbr());
                    }
                }

                if ($err==FALSE and $ds->ModifyIP($ip, $baseindex, $user, $location, 
                            $telno, $descrip, $hname, $info) == 0) {
                    $ds->DbfTransactionEnd();
                    insert($w,text(my_("IP address details modified")));
                }
                else {
                    insert($w,text(my_("IP address details could not be modified"),
                                array("color"=>"#FF0000")));
                }
            }
        }
        else
            insert($w,text(my_("You are not the owner of the subnet"),
                        array("color"=>"#FF0000")));
    }
    else
        insert($w,text(my_("Could not find the owner of the subnet - subnet possibly deleted by another user")."<br>",
                    array("color"=>"#FF0000")));
}
    
// get info from base table
$result=$ds->GetBaseFromIndex($baseindex);

$row = $result->FetchRow();
$maxcnt=$row["subnetsize"];
$baseaddr=$row["baseaddr"];

// sanity check if MAXTABLESIZE in config.php is modified on the fly
// and person has maybe bookmarked paged
if ($baseaddr+$block*MAXTABLESIZE >= $baseaddr+$maxcnt) {
   myError($w, my_("This page was bookmarked and contains invalid information which cannot be displayed anymore - restart from main menu"));
}

insert($w,block("<h3>"));
insert($w,text(my_("Subnet:")." ".
                  inet_ntoa($baseaddr)." ".my_("Mask:")." ".
                  inet_ntoa(inet_aton(ALLNETS)+1 -
                    $maxcnt)."/".inet_bits($maxcnt)));
insert($w,textbr());
insert($w,text(my_("Description:")." ".$row["descrip"]));
insert($w,block("</h3>"));

if ($showactive) {
   // increase time limit for scans - will have no effect if safe mode is on
   @set_time_limit(90);
}
else {
   insert($w,anchor($PHP_SELF."?baseindex=".$baseindex."&showactive=1&block=".$block,
                    my_("Show used addresses")));
 
   insert($w,textbr(my_(" This can take a while as each address is polled.  Green is active, Red is inactive")));
}
if ($showdns) {
   // increase time limit for dns query - will have no effect in safe mode is on
   @set_time_limit(90);
}
else {
   insert($w,anchor($PHP_SELF."?baseindex=".$baseindex."&showdns=1&block=".$block,
                    my_("Show DNS changes")));
 
   insert($w,textbr(my_(" Show descriptions that do not match DNS reverse entries. Red is new DNS value")));
}

insert($w,block("<p>"));

// only display stats for networks with more than 1 host
if ($maxcnt > 1) {
    insert($w,$tbig = table(array("cols"=>"3")));
    insert($tbig,$c = cell());
    insert($c,textbr(my_("Select multiple addresses to do a bulk change")));
    insert($c,text(my_("Ideal for reserving DHCP ranges")));

    // start form for drop down list
    insert($c, $f = form(array("name"=>"MODIFYMULTIPLE",
                    "method"=>"post",
                    "action"=>"modifyipformmul.php")));

    // build "option select" list
    $lst=array();
    for ($i=$block*MAXTABLESIZE; $i < $block*MAXTABLESIZE+MAXTABLESIZE; $i++) {
        if ($i > 0 and $i < $maxcnt-1) {
            $col=$row["baseaddr"]+$i;
            $lst["$col"]=inet_ntoa($row["baseaddr"]+$i);
        }
    }
    insert($f,selectbox($lst,
                array("name"=>"ip[]", 
                    "multiple size"=>"5")));

    insert($f,hidden(array("name"=>"baseindex",
                    "value"=>"$baseindex")));
    insert($f,hidden(array("name"=>"block",
                    "value"=>"$block")));

    insert($f,generic("br"));
    insert($f,submit(array("value"=>my_("Submit"))));
    insert($f,freset(array("value"=>my_("Clear"))));

    // start form for "Use next address" button
    insert($c, $f = form(array("name"=>"MODIFYNEXTFREE",
                    "method"=>"get",
                    "action"=>"modifyipform.php")));

    insert($f,hidden(array("name"=>"baseindex",
                    "value"=>"$baseindex")));
    insert($f,hidden(array("name"=>"baseaddr",
                    "value"=>"$baseaddr")));
    insert($f,hidden(array("name"=>"block",
                    "value"=>"$block")));

    insert($f,submit(array("value"=>my_("Use next available address"))));

    insert($tbig,$c = cell());
    // create stats cell for later use
    insert($tbig,$cstats = cell(array("valign"=>"top")));
}

// get detail from ipaddr table - could be nothing!
$result=$ds->GetSubnetDetails($baseindex);
// emulate for databases that do not have RecordCount
$recs=$result->PO_RecordCount("ipaddr", "baseindex=$baseindex");

// create a table
insert($w,$tbig = table(array("cols"=>"1", "bgcolor"=>"#00CCFF")));
insert($tbig,$c = cell());
insert($c,$t = table(array("cols"=>"7",
                           "cellspacing"=>"1",
                           "bgcolor"=>"#99CCFF")));
// draw heading
insert($t,$ck1 = cell());
// display preceding cell later
insert($t,$c = cell());
insert($c,textb(my_("User")));
insert($t,$c = cell());
insert($c,textb(my_("Location")));
insert($t,$c = cell());
insert($c,textb(my_("Device description")));
insert($t,$c = cell());
insert($c,textb(my_("Telephone Number")));
insert($t,$c = cell());
insert($c,textb(my_("Last modified")));
insert($t,$ck2 = cell());
insert($ck2,textb(my_("Changed by")));

 
// fastforward till first record if not first block of data
while ($row = $result->FetchRow() and 
       $row["ipaddr"] < $baseaddr+($block*MAXTABLESIZE));

$res=0;
for ($i=$block*MAXTABLESIZE; $i < $block*MAXTABLESIZE+MAXTABLESIZE; $i++) {
setdefault("cell",array("bgcolor"=>color_flip_flop()));

   // did user select to scan if address is active?
   if ($showactive) {
      if (ScanHost(inet_ntoa($baseaddr+$i)))
         insert($t,$c = cell(array("bgcolor"=>"#00FF00")));
      else
         insert($t,$c = cell(array("bgcolor"=>"#FF0000")));
   }
   else {
      insert($t,$c = cell());
   }

   // strange! brackets must be there in php 4.0.4p1, else code wrong!
   insert($c,anchor("modifyipform.php?ip=".($baseaddr+$i).
                    "&baseindex=".$baseindex."&block=".$block,
                    inet_ntoa($baseaddr+$i)));
 
   insert($t,$c = cell());
   // network address
   if ($i == 0) {
      insert($c,text(my_("Reserved - network address"), 
                array("color"=>"#FF0000")));
      insert($c,textbr());
   }
   // broadcast address
   else if ($i == $maxcnt-1) {
      insert($c,text(my_("Reserved - broadcast address"), 
                array("color"=>"#FF0000")));
      insert($c,textbr());
   }
   // display only rows that exist in database
   if ($row["ipaddr"] == $baseaddr+$i) {
      // count reserved addresses
      if ($i == 0 or $i == $maxcnt-1)
         $res++;
      insert($c,text($row["userinf"]));
      insert($t,$c = cell());
      insert($c,text($row["location"]));
      insert($t,$c = cell());
      insert($c,text($row["descrip"]));
      if ($showdns) {
         $dnsdescrip=gethostbyaddr(inet_ntoa($baseaddr+$i));
         if ($dnsdescrip != inet_ntoa($baseaddr+$i) and 
             $dnsdescrip != $row["hname"]) {
            if (!empty($row["hname"])) {
               insert($c,textbr());
            }
            insert($c,text($dnsdescrip, array("color"=>"#FF0000")));
         }
      }
      if (!empty($row["hname"])) {
         insert($c,textbr());
         insert($c,block("<small><i>"));
         insert($c,text($row["hname"]));
         insert($c,block("</i></small>"));
      }
      insert($t,$c = cell());
      insert($c,text($row["telno"]));
      insert($t,$c = cell());
      insert($c,block("<small>"));
      insert($c,block($result->UserTimeStamp($row["lastmod"], "M d Y H:i:s")));
      insert($c,block("</small>"));
      insert($t,$c = cell());
      insert($c,text($row["userid"]));

      $row = $result->FetchRow();
   }
   else {
      insert($t,$c = cell());
      insert($t,$c = cell());
      if ($showdns) {
         $dnsdescrip=gethostbyaddr(inet_ntoa($baseaddr+$i));
         if ($dnsdescrip!=inet_ntoa($baseaddr+$i)) {
            insert($c,text($dnsdescrip, array("color"=>"#FF0000")));
         }
      }
      insert($t,$c = cell());
      insert($t,$c = cell());
      insert($t,$c = cell());
   }

   // exit loop when subnet is done - protects against MAXTABLESIZE
   // not being a power of two (eg 64, 128 etc)
   if ($baseaddr+$i >= $baseaddr+$maxcnt-1) {
      break;
   }
}

insert($w,block("<p>"));

// only display stats for networks with more than 1 host
if ($maxcnt > 1) {
    // display stats
    $res=2-$res;
    insert($cstats,textb(my_("Subnet Summary")));
    insert($cstats,block("<p>"));
    insert($cstats,textbr(my_("Total addresses:")." ".$maxcnt));
    insert($cstats,textbr(my_("Used addresses:")." ".($recs+$res)));
    insert($cstats,textbr(my_("Free addresses:")." ".($maxcnt-$recs-$res)));
    insert($cstats,textbr(my_("Utilization:")." ".(round(($recs+$res)/$maxcnt*100,2))."%"));
    insert($cstats,textbr(my_("Efficiency:")." ".(round(($recs)/$maxcnt*100,2))."%"));
}

// display various blocks of subnet
$cnt=0;
$vars="";
for ($i=$baseaddr; $i<$baseaddr+$maxcnt; $i=$i+MAXTABLESIZE) {
    if ($block != $cnt) {
       if ($i+MAXTABLESIZE >= $baseaddr+$maxcnt-1) {
          $vars=$PHP_SELF."?baseindex=".$baseindex."&block=".$cnt."&showactive=".$showactive;
          insert($w,anchor($vars,
                           inet_ntoa($i)." - ".inet_ntoa($baseaddr+$maxcnt-1)));
       }
       else {
          $vars=$PHP_SELF."?baseindex=".$baseindex."&block=".$cnt."&showactive=".$showactive;
          insert($w,anchor($vars,
                           inet_ntoa($i)." - ".inet_ntoa($i+MAXTABLESIZE-1)));
       }

    insert($w,textbr());
    }
    $cnt++;
}
if ($block > 0) {
    $vars=$PHP_SELF."?baseindex=".$baseindex."&block=".($block-1)."&showactive=".$showactive;
    insert($ck1,anchor($vars, "<<"));
}
if ($cnt-1 != $block) {
    $vars=$PHP_SELF."?baseindex=".$baseindex."&block=".($block+1)."&showactive=".$showactive;
    insert($ck2,anchor($vars, ">>"));
}
insert($ck1,textb(my_("IP address")));

$result->Close();
printhtml($w);

?>
