<?php

// IPplan v4.04
// Aug 24, 2001
//
// Modified by Tony D. Koehn February 2003
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// save the last customer used
// must set path else Netscape gets confused!
setcookie("ipplanCustomer","$cust",time() + 10000000, "/");

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("DNS Domain Zones");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
$cust=floor($cust);
$dataid=floor($dataid);
$serialnum=(int)$serialnum;
$ttl=(int)$ttl;
$refresh=(int)$refresh;
$retry=(int)$retry;
$expire=(int)$expire;
$minimum=(int)$minimum;
//if (!$HTTP_GET_VARS) {
//   myError($w, my_("You cannot reload or bookmark this page!"));
//}

// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

// CHECK Actions First

// ##################### Start OF DELETE ##############################
if ($action=="delete") {
    // check if user belongs to customer admin group
    $result=$ds->GetCustomerGrp($cust);
    // can only be one row - does not matter if nothing is 
    // found as array search will return false
    $row = $result->FetchRow();
    if (!in_array($row["admingrp"], $grps)) {
        myError($w, my_("You may not delete a DNS zone as you are not a member of the customers admin group"));
    } 

    // check for records
    $result = &$ds->ds->Execute("SELECT recidx 
            FROM fwdzonerec 
            WHERE customer=$cust AND data_id=$dataid");
    $recs=$result->PO_RecordCount("fwdzonerec", "customer=$cust AND data_id=$dataid");
    if ($recs) {
        myError($w, my_("Cannot delete domain zone - there are still DNS records"));
    }

    // Log the Transaction.
    $ds->DbfTransactionStart();
    $result = $ds->ds->Execute("DELETE FROM fwdzone 
            WHERE customer=$cust AND data_id=$dataid") and
              $ds->ds->Execute("DELETE FROM fwddns 
            WHERE id=$dataid") and
        $ds->AuditLog(sprintf(my_("User %s Deleted DNS zone %s"),
                    $HTTP_SERVER_VARS[AUTH_VAR], $domain));

    $ds->DbfTransactionEnd();

    if ($result) {
        $ds->DbfTransactionEnd();
        insert($w,textbr(my_("DNS Zone deleted")));
        $zone="";
    }
    else {
        $ds->DbfTransactionRollback();
        $formerror .= my_("DNS Zone could not be deleted")."<br>";
    }
}
// ##################### END OF DELETE ##############################

// ##################### Start OF checks ##############################
if ($action=="add" or $action=="edit") {
    // check if user belongs to customer admin group
    $result=$ds->GetCustomerGrp($cust);
    // can only be one row - does not matter if nothing is 
    // found as array search will return false
    $row = $result->FetchRow();
    if (!in_array($row["admingrp"], $grps)) {
        myError($w, my_("You may not add a zone as you are not a member of the customers admin group"));
    } 

    // Error Checks
    if (!$domain)
        myError($w, my_("Domain may not be blank"));
    if (!preg_match('/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/', $domain))
        myError($w, my_("Invalid domain name"));

    $cnt=0;
    for ($i = 1; $i < 11; $i++) {
        if ($hname[$i] and
                !preg_match("/[^ \t@()<>,]+\\.[^ \t()<>,.]+$/", $hname[$i])) {
            myError($w, sprintf(my_("Invalid hostname %u"), $i)."<br>");
        }
        if ($hname[$i]) {
            $cnt++;
        }
    }
    if ($cnt < 2) {
        myError($w, my_("Invalid zone - you need at least two nameservers"));
    }

    if (!is_numeric($ttl) or !is_numeric($refresh) or !is_numeric($retry) or
        !is_numeric($expire) or !is_numeric($minimum)) {
        myError($w, my_("Invalid domain timeout values"));
    }

    if (!$serialdate)
        myError($w, my_("Serial Date can not be blank. Use YYYYMMDD."));

}

// ##################### Start OF Add ##############################
if ($action=="add") {
    // could use unique key on database to do check, but requires extra key
    // just to add a new record
    $restemp=&$ds->ds->Execute("SELECT domain FROM fwdzone 
                                WHERE customer=$cust AND domain = ".$ds->ds->qstr($domain));

    if ($restemp->FetchRow()) {
        insert($w,text(sprintf(my_("DNS Domain %s could not be created - possibly duplicate zone"), $domain), array("color"=>"red")));
        insert($w,textbr());
    }
    else {
        // Add to DB here.
        // Log the Transaction.
        $ds->DbfTransactionStart();
        $result = &$ds->ds->Execute("INSERT into fwdzone (customer, 
        domain, lastmod, serialdate, serialnum, ttl, refresh, retry, expire, minimum, 
        zonefilepath1, zonefilepath2) ".
                "VALUES ($cust,".
                $ds->ds->qstr($domain).",".
                $ds->ds->DBTimeStamp(time()).",".
                $ds->ds->qstr($serialdate).", $serialnum,".
                $ttl.",".
                $refresh.",".
                $retry.",".
                $expire.",".
                $minimum.",".
                $ds->ds->qstr($zonepath).",".
                $ds->ds->qstr($seczonepath).")" );

        // did not fail due to key error?
        if ($result) {
            if (DBF_TYPE=="mysql" or DBF_TYPE=="maxsql") {
                $dataid=$ds->ds->Insert_ID();
            }
            else {
                // emulate getting the last insert_id
                $result=&$ds->ds->Execute("SELECT data_id 
                        FROM fwdzone
                        WHERE customer=$cust AND 
                        domain=".$ds->ds->qstr($domain));
                $temprow = $result->FetchRow();
                $dataid=$temprow["data_id"];
            }

            // add reverse DNS into fwddns table
            for ($i = 1; $i < 11; $i++) {
                if ($hname[$i]) {
                    $hnametemp=$hname[$i];

                    // add DNS records
                    $result=&$ds->ds->Execute("INSERT INTO fwddns
                            (id, hname, horder)
                            VALUES
                            ($dataid,
                             ".$ds->ds->qstr($hnametemp).",
                             $i)");
                }
            }
        }

        if ($result) {
            $ds->AuditLog(sprintf(my_("User %s added DNS zone %s"),
                        $HTTP_SERVER_VARS[AUTH_VAR], $domain));

            $ds->DbfTransactionEnd();
            insert($w,textbr(my_("DNS Zone created")));
        }
        else {
            $ds->DbfTransactionRollback();
            $formerror .= my_("DNS Zone could not be created - probably duplicate Domain")."<br>";
        }
    }
}
// ##################### END OF Add ##############################

// ##################### Start OF Edit ##############################
if ($action=="edit") {
    // Updated DB here.
    // Log the Transaction.
    $ds->DbfTransactionStart();
    $result = &$ds->ds->Execute("UPDATE fwdzone ".
            "set serialdate=".$ds->ds->qstr($serialdate).
            ", serialnum=$serialnum".
            ",ttl=".$ttl.
            ",refresh=".$refresh.
            ",retry=".$retry.
            ",expire=".$expire.
            ",minimum=".$minimum.
            ",zonefilepath1=".$ds->ds->qstr($zonepath).
            ",zonefilepath2=".$ds->ds->qstr($seczonepath).
            ",lastmod=".$ds->ds->DBTimeStamp(time()).
            "WHERE customer=$cust AND data_id=".$dataid );

    // delete all the DNS records first to preserve correct order
    $result=&$ds->ds->Execute("DELETE FROM fwddns
            WHERE id=$dataid");

    // add reverse DNS into fwdzone table
    for ($i = 1; $i < 11; $i++) {
        if ($hname[$i]) {
            $hnametemp=$hname[$i];

            // add DNS records
            $result=&$ds->ds->Execute("INSERT INTO fwddns
                    (id, hname, horder)
                    VALUES
                    ($dataid,
                     ".$ds->ds->qstr($hnametemp).",
                     $i)");
        }
    }

    if ($result) {
        $ds->AuditLog(sprintf(my_("User %s modified dns zone %s"),
                    $HTTP_SERVER_VARS[AUTH_VAR], $domain));

        $ds->DbfTransactionEnd();
        insert($w,textbr(my_("DNS Zone Modified")));
    }
    else {
        $ds->DbfTransactionRollback();
        $formerror .= my_("DNS Zone could not be modifed. Try again.")."<br>";
    }
}
// ##################### END OF Edit ##############################

// ##################### Start OF EXPORT DNS Servers  ##############################
if ($action=="export") {
    // check if user belongs to customer admin group
    $result=$ds->GetCustomerGrp($cust);
    // can only be one row - does not matter if nothing is 
    // found as array search will return false
    $row = $result->FetchRow();
    if (!in_array($row["admingrp"], $grps)) {
        myError($w, my_("You may not add a zone as you are not a member of the customers admin group"));
    } 
    // Update serialcount
    $now = getdate();
    $newserialdate = $now[year] . str_pad($now[mon], 2, '0', STR_PAD_LEFT) . str_pad( $now[mday], 2, '0', STR_PAD_LEFT);
    if ($serialdate==$newserialdate) {
        $serialnum++;
    }else{
        $serialdate=$newserialdate;
        $serialnum=0;
    }
    // Update DNS Database Serial Count.  Update Serial Count only when we export.
    $result = &$ds->ds->Execute("UPDATE fwdzone ".
            "set serialdate=".$ds->ds->qstr($serialdate).
            ", serialnum=$serialnum".
            " WHERE customer=$cust AND data_id=".$dataid);

    $result = &$ds->ds->Execute("SELECT * FROM fwdzone 
            WHERE customer=$cust AND data_id=$dataid");
    $row = $result->FetchRow();

    $tmpfname = tempnam (DNSEXPORTPATH, "zone_") or
        myError($w, my_("Could not create temporary file!"));
    $fp = fopen ("$tmpfname", "w");

    // header of document
    $output='<?xml version="1.0" ?>';
    fputs($fp, $output);
    fputs($fp, "\n");
    fputs($fp, sprintf('<zone domain="%s">', $row["domain"]));
    fputs($fp, "\n");

    // SOA portion
    fputs($fp, sprintf('<soa serialdate="%s" serialnum="%02d" ttl="%s" retry="%s" refresh="%s" expire="%s" minimumttl="%s" email="%s" />', 
                $serialdate, $serialnum, 
                $row["ttl"],
                $row["retry"],
                $row["refresh"],
                $row["expire"],
                $row["minimum"],
                $row["responsiblemail"]
                ));
    fputs($fp, "\n");

    // nameservers
    $result1 = &$ds->ds->Execute("SELECT hname
            FROM fwddns
            WHERE id=$dataid
            ORDER BY horder");

    $cnt=0;
    while($row1 = $result1->FetchRow()) {
        fputs($fp, '<record type="NS">');
        fputs($fp, sprintf('<iphostname>%s</iphostname>', $row1["hname"]));
        fputs($fp, '</record>');
        fputs($fp, "\n");

        $cnt++;
    }
    if ($cnt < 2) {
        insert($w,textbr(my_("Invalid zone - zone should have at least two name servers defined")));
    }

    $result = &$ds->ds->Execute("SELECT * FROM fwdzonerec
            WHERE customer=$cust AND data_id=$dataid
            ORDER BY sortorder");
    // loop through each host record
    while($row = $result->FetchRow()) {
        fputs($fp, sprintf('<record><%s>', $row["recordtype"]));
        fputs($fp, sprintf('<host>%s</host>', $row["host"]));
        fputs($fp, sprintf('<iphostname>%s</iphostname>', $row["ip_hostname"]));
        fputs($fp, sprintf('</%s></record>', $row["recordtype"]));
        fputs($fp, "\n");
    }
    // close zone
    fputs($fp, '</zone>');
    fputs($fp, "\n");

    fclose($fp);

    insert($w,textbr(sprintf(my_("Sent update to Backend Processor as file %s"), $tmpfname)));
}
// ##################### END OF Update DNS Servers  ##############################
// Now Setup Page...

// start form
insert($w, $f1 = form(array("name"=>"THISFORM",
                            "method"=>"post",
                            "action"=>"$PHP_SELF")));

// ugly kludge with global variable!
$displayall=FALSE;
$cust=myCustomerDropDown($ds, $f1, $cust, $grps) or myError($w, my_("No customers"));

// get info from base table
$result = &$ds->ds->Execute("SELECT * FROM fwdzone 
                             WHERE customer=$cust ORDER BY domain ");

$totcnt=0;
// fastforward till first record if not first block of data
while ($block and $totcnt < $block*MAXTABLESIZE and
       $row = $result->FetchRow()) {
    DisplayTextBlock($w, $row, $totcnt, "&start=".$start, $row["domain"] );
    $totcnt++;
}
insert($w,block("<p>"));

// create a table
insert($w,$tbig = table(array("cols"=>"1", "bgcolor"=>"#00CCFF")));
insert($tbig,$c = cell());
insert($c,$t = table(array("cols"=>"10",
                           "cellspacing"=>"1",
                           "bgcolor"=>"#99CCFF")));
// draw heading
insert($t,$c = cell());
insert($c,textb(my_("Domain")));
insert($t,$c = cell());
insert($c,textb(my_("Primary NS")));
insert($t,$c = cell());
insert($c,textb(my_("Secondary NS")));
insert($t,$c = cell());
insert($c,textb(my_("SerialDate")));
insert($t,$c = cell());
insert($c,textb(my_("TTL")));
insert($t,$c = cell());
insert($c,textb(my_("Refresh")));
insert($t,$c = cell());
insert($c,textb(my_("Retry")));
insert($t,$c = cell());
insert($c,textb(my_("Expire")));
insert($t,$c = cell());
insert($c,textb(my_("Min. TTL")));
insert($t,$c = cell());
insert($c,textb(my_("Action")));


$cnt=0;
while($row = $result->FetchRow()) {
setdefault("cell",array("bgcolor"=>color_flip_flop()));

    insert($t,$c = cell());
    insert($c,text($row["domain"]));

    $result1 = &$ds->ds->Execute("SELECT hname FROM fwddns
                                  WHERE id=".$row["data_id"]."
                                  ORDER BY horder");

    insert($t,$c = cell());
    $row1 = $result1->FetchRow();
    insert($c,text($row1["hname"]));

    insert($t,$c = cell());
    $row1 = $result1->FetchRow();
    insert($c,text($row1["hname"]));

    insert($t,$c = cell());
    insert($c,text($row["serialdate"].str_pad($row["serialnum"], 2, '0', STR_PAD_LEFT)));

    insert($t,$c = cell());
    insert($c,text($row["ttl"]));

    insert($t,$c = cell());
    insert($c,text($row["refresh"]));

    insert($t,$c = cell());
    insert($c,text($row["retry"]));

    insert($t,$c = cell());
    insert($c,text($row["expire"]));

    insert($t,$c = cell());
    insert($c,text($row["minimum"]));

    insert($t,$c = cell());
    insert($c,block("<small>"));
    insert($c,anchor($PHP_SELF."?cust=$cust&dataid=".$row["data_id"]."&action=delete&domain=".$row["domain"], my_("Delete DNS Zone"),
                $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
    insert($c,block(" | "));
    insert($c,anchor("modifydnsform.php?cust=$cust&dataid=".$row["data_id"].
                "&action=edit".
                "&domain=".$row["domain"].
                "&serialdate=".$row["serialdate"].
                "&serialnum=".$row["serialnum"].
                "&ttl=".$row["ttl"].
                "&retry=".$row["retry"].
                "&refresh=".$row["refresh"].
                "&expire=".$row["expire"].
                "&minimum=".$row["minimum"].
                "&zonepath=".$row["zonefilepath1"].
                "&seczonepath=".$row["zonefilepath2"],
                my_("Edit DNS Zone")));
    insert($c,block(" | "));
    insert($c,anchor($PHP_SELF."?cust=$cust&dataid=".$row["data_id"].
                "&action=export".
                "&domain=".$row["domain"].
                "&serialdate=".$row["serialdate"].
                "&serialnum=".$row["serialnum"].
                "&ttl=".$row["ttl"].
                "&retry=".$row["retry"].
                "&refresh=".$row["refresh"].
                "&expire=".$row["expire"].
                "&minimum=".$row["minimum"].
                "&zonepath=".$row["zonefilepath1"].
                "&seczonepath=".$row["zonefilepath2"],
                my_("Export DNS Zone"),
                $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure to Export?")."')") : FALSE));
    insert($c,block("</small>"));
    $cnt++;
    $totcnt++;
    if ($totcnt % MAXTABLESIZE == MAXTABLESIZE-1)
        break;
}

insert($w,block("<p>"));

while ($row = $result->FetchRow()) {
    $totcnt++;
    DisplayTextBlock($w, $row, $totcnt, "&start=".$start, $row["domain"] );
}

if (!$cnt) {
   insert($w,text(my_("Search found no DNS Zone entries"), array("color"=>"red")));
}

insert($w, $f = form(array("method"=>"post",
                           "action"=>"modifydnsform.php?cust=$cust&action=add")));
insert($f,submit(array("value"=>my_("Add a DNS Zone"))));


$result->Close();
printhtml($w);

?>
