<?php

// IPplan v4.04
// Aug 24, 2001
//
// Modified by Tony D. Koehn Feburary 2003
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// save the last customer used
// must set path else Netscape gets confused!
setcookie("ipplanCustomer","$cust",time() + 10000000, "/");

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Create DNS Zones");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
$cust=floor($cust);
$dataid=floor($dataid);
if (!$HTTP_GET_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

$now = getdate();
$newserialdate = $now[year] . str_pad($now[mon], 2, '0', STR_PAD_LEFT) . str_pad( $now[mday], 2, '0', STR_PAD_LEFT);
if ($serialdate=$newserialdate) {
   $serialnum++;
}else{
   $serialdate=$newserialdate;
   $serialnum=0;
}

insert($w, $f = form(array("method"=>"post",
                           "action"=>"modifydns.php")));

// Use the same form for adding or editing.  Setup page & variables based on action.
if ($action=='add') {
    $zone="";

    $ttl=DNSTTL;
    $refresh=DNSREFRESH;
    $retry=DNSRETRY;
    $expire=DNSEXPIRE;
    $minimum=DNSMINTTL;   
    $zonepath="master/db.";
    $seczonepath="slave/db.";
    insert($f,hidden(array("name"=>"action", "value"=>"add")));
    $myTitle="Add";
}else{
   insert($f,hidden(array("name"=>"action", "value"=>"edit")));
   insert($f,hidden(array("name"=>"dataid", "value"=>"$dataid")));
   $myTitle="Edit";
}
insert($f,hidden(array("name"=>"cust", "value"=>"$cust")));
insert($f,hidden(array("name"=>"serialdate", "value"=>"$serialdate")));
insert($f,hidden(array("name"=>"serialnum", "value"=>"$serialnum")));

insert($f,textbrbr(my_("$myTitle a Zone")));
insert($f,textbr(my_("----------------")));

insert($f,textbrbr(my_("Zone (Domain Name)")));

insert($f,input_text(array("name"=>"domain",
                           "value"=>"$domain",
                           "size"=>"30",
                           "maxlength"=>"30")));

// if creating new zone, get dns servers from revdns table
if ($action=="add") {
    $result2=&$ds->ds->Execute("SELECT hname 
            FROM revdns
            WHERE customer=$cust");
}
else {
    $result2=&$ds->ds->Execute("SELECT hname 
            FROM fwddns
            WHERE id=$dataid");
}
 
$i=1;
while($row2 = $result2->FetchRow()) {
   $hname[$i]=$row2["hname"];
   $i++;
}

// space for 10 reverse entries
for ($i=1; $i < 11; $i++) {
    insert($f,textbrbr(sprintf(my_("Name server %u:"), $i)));
    insert($f,input_text(array("name"=>"hname[".$i."]",
                               "value"=>$hname[$i],
                               "size"=>"80",
                               "maxlength"=>"80")));
}

insert($f,block("<p>"));
insert($f,textbr(my_("TTL")));
insert($f,input_text(array("name"=>"ttl",
                           "value"=>"$ttl",
                           "size"=>"30",
                           "maxlength"=>"30")));

insert($f,textbrbr(my_("Refresh")));
insert($f,input_text(array("name"=>"refresh",
                           "value"=>"$refresh",
                           "size"=>"5",
                           "maxlength"=>"30")));

insert($f,textbrbr(my_("Retry")));
insert($f,input_text(array("name"=>"retry",
                           "value"=>"$retry",
                           "size"=>"5",
                           "maxlength"=>"30")));

insert($f,textbrbr(my_("Expire")));
insert($f,input_text(array("name"=>"expire",
                           "value"=>"$expire",
                           "size"=>"5",
                           "maxlength"=>"30")));

insert($f,textbrbr(my_("Minimum TTL")));
insert($f,input_text(array("name"=>"minimum",
                           "value"=>"$minimum",
                           "size"=>"5",
                           "maxlength"=>"30")));

insert($f,textbrbr(my_("Zone File Path")));
insert($f,input_text(array("name"=>"zonepath",
                           "value"=>"$zonepath",
                           "size"=>"30",
                           "maxlength"=>"30")));

insert($f,textbrbr(my_("Secondary Zone File Path")));
insert($f,input_text(array("name"=>"seczonepath",
                           "value"=>"$seczonepath",
                           "size"=>"30",
                           "maxlength"=>"30")));

insert($f,generic("br"));
insert($f,submit(array("value"=>my_("Save"))));
insert($f,freset(array("value"=>my_("Clear"))));

printhtml($w);

?>
