<?php

// IPplan v4.04
// Aug 24, 2001
//
// Modified by Tony D. Koehn February 2003
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// save the last customer used
// must set path else Netscape gets confused!
setcookie("ipplanCustomer","$cust",time() + 10000000, "/");

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Zone Domain DNS Records");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
$cust=floor($cust);
$dataid=floor($dataid);
$zoneid=floor($zoneid);
$sortorder=(int)$sortorder;
// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

// CHECK Actions First

// ##################### Start OF DELETE ##############################
if ($action=="delete") {
    // check if user belongs to customer admin group
    $result=$ds->GetCustomerGrp($cust);
    // can only be one row - does not matter if nothing is 
    // found as array search will return false
    $row = $result->FetchRow();
    //   if (!in_array($row["admingrp"], $grps)) {
    //      myError($w, my_("You may not delete dns records as you are not a member of the customers admin group"));
    //   } 

    // Log the Transaction.
    $ds->DbfTransactionStart();
    $result = &$ds->ds->Execute("DELETE FROM fwdzonerec 
            WHERE customer=$cust AND recidx=$dataid") and
        $ds->AuditLog(sprintf(my_("User %s Deleted DNS Record for domain %s Host=%s, RecordType=%s, IPHostname=%s"),
                    $HTTP_SERVER_VARS[AUTH_VAR], $domain, $host, $recordtype, $iphostname));

    $ds->DbfTransactionEnd();

    if ($result) {
        $ds->DbfTransactionEnd();
        insert($w,textbr(my_("Domain DNS Record Deleted.")));
        $zone="";
    } else {
        $ds->DbfTransactionRollback();
        $formerror .= my_("DNS Record could not be deleted.")."<br>";
    }
}
// ##################### END OF DELETE ##############################

// ##################### Start OF Add ##############################
if ($action=="add") {
    // check if user belongs to customer admin group
    $result=$ds->GetCustomerGrp($cust);
    // can only be one row - does not matter if nothing is 
    // found as array search will return false
    $row = $result->FetchRow();
    //   if (!in_array($row["admingrp"], $grps)) {
    //      myError($w, my_("You may not add a record as you are not a member of the customers admin group"));
    //  } 

    // Error Checks
    if ($recordtype=="MX") {   // MX could have no hostname
        if ($host and !preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $host))
            myError($w, my_("Invalid hostname"));
    } else {
        if (!$host)
            myError($w, my_("Host may not be blank"));
        if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $host))
            myError($w, my_("Invalid hostname"));
    }
    if (!$recordtype)
        myError($w, my_("Record Type may not be blank."));
    if (!$sortorder or $sortorder < 1)
        $sortorder=9999;
    if (!$iphostname)
        myError($w, my_("IP / Hostname may not be blank."));
    if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $iphostname))
        myError($w, my_("Invalid IP/ Hostname"));
    // add . after record - don't understand thinking here? User should determine if
    // qualified or not?
    /*
       if(preg_match("/[a-z]/i",$iphostname) && substr($iphostname,-1) != '.') {
       $iphostname .= '.';
       }
     */
    // iphostname must be IP address
    if ($recordtype=="A" and testIP($iphostname))
        myError($w, my_("For A type, IP / Hostname must be an IP address"));
    // need to check for valid host
    if ($recordtype=="CNAME" or $recordtype=="MX") {
        if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $iphostname))
            myError($w, my_("Invalid IP/ Hostname"));
    }

    // Add to DB here.
    // Log the Transaction.
    $ds->DbfTransactionStart();

    $result = &$ds->ds->Execute("INSERT into fwdzonerec 
            (customer, data_id, sortorder, lastmod, host, 
             recordtype, ip_hostname) ".
            "VALUES ($cust, $zoneid, ". $sortorder.",".
            $ds->ds->DBTimeStamp(time()).",".
            $ds->ds->qstr($host).",".
            $ds->ds->qstr($recordtype).",".
            $ds->ds->qstr($iphostname).")" ) and
        $ds->AuditLog(sprintf(my_("User %s added host for domain %s, host=%s, RecordType=%s, IP/Hostname=%s."),
                    $HTTP_SERVER_VARS[AUTH_VAR], $domain, $host, $recordtype, $iphostname));

    if ($result) {
        $ds->DbfTransactionEnd();
        insert($w,textbr(my_("Host record added.")));
        $zone="";
    } else {
        $ds->DbfTransactionRollback();
        $formerror .= my_("Host record could not be added.")."<br>";
    }
}
// ##################### END OF Add ##############################

// ##################### Start OF Edit ##############################
if ($action=="edit") {
    // check if user belongs to customer admin group
    $result=$ds->GetCustomerGrp($cust);
    // can only be one row - does not matter if nothing is 
    // found as array search will return false
    $row = $result->FetchRow();
    // Modified 3-18-04 
    //   if (!in_array($row["admingrp"], $grps)) {
    //      myError($w, my_("You may not edit a zone as you are not a member of the customers engineer group"));
    //   } 

    // Error Checks
    if ($recordtype=="MX") {   // MX could have no hostname
        if ($host and !preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $host))
            myError($w, my_("Invalid hostname"));
    } else {
        if (!$host)
            myError($w, my_("Host may not be blank"));
        if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $host))
            myError($w, my_("Invalid hostname"));
    }
    if (!$recordtype)
        myError($w, my_("Record Type may not be blank."));
    if (!$sortorder or $sortorder < 1)
        $sortorder=9999;
    if (!$iphostname)
        myError($w, my_("IP / Hostname may can not be blank"));
    if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $iphostname))
        myError($w, my_("Invalid IP / Hostname"));
    /*
       if(preg_match("/[a-z]/i",$iphostname) && substr($iphostname,-1) != '.') {
       $iphostname .= '.';
       }
     */
    // iphostname must be IP address
    if ($recordtype=="A" and testIP($iphostname))
        myError($w, my_("For A type, IP / Hostname must be an IP address"));
    // need to check for valid host
    if ($recordtype=="CNAME" or $recordtype=="MX") {
        if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?\.?$/', $iphostname))
            myError($w, my_("Invalid IP/ Hostname"));
    }

    // Updated DB here.
    // Log the Transaction.
    $ds->DbfTransactionStart();

    $result = &$ds->ds->Execute("UPDATE fwdzonerec SET sortorder=".$sortorder.
            ", host=".$ds->ds->qstr($host).
            ", lastmod=".$ds->ds->DBTimeStamp(time()).
            ", recordtype=".$ds->ds->qstr($recordtype).
            ", ip_hostname=".$ds->ds->qstr($iphostname).
            "WHERE customer=$cust AND recidx=".$dataid ) and
        $ds->AuditLog(sprintf(my_("User %s modified dns record for domain %s, host=%s, RecordType=%s, IP/Hostname=%s."),
                    $HTTP_SERVER_VARS[AUTH_VAR], $domain, $host, $recordtype, $iphostname));

    if ($result) {
        $ds->DbfTransactionEnd();
        insert($w,textbr(my_("Host Record Modified")));
        $zone="";
    }
    else {
        $ds->DbfTransactionRollback();
        $formerror .= my_("Host record could not be modifed. Try again.")."<br>";
    }
}
// ##################### END OF Edit ##############################

// start form
insert($w, $f1 = form(array("name"=>"THISFORM",
                            "method"=>"post",
                            "action"=>"$PHP_SELF")));

// ugly kludge with global variable!
$displayall=FALSE;
$cust=myCustomerDropDown($ds, $f1, $cust, $grps) or myError($w, my_("No customers"));

//
// Get a List of Domains from the fwdzone table.
//

$result = &$ds->ds->Execute("SELECT domain, data_id FROM fwdzone 
                            WHERE customer=$cust
                            ORDER BY domain");
if (!$result) {
   myError($w, my_("No domains found. Create some domains and try again."));
}

insert($w, $f2 = form(array("name"=>"DomainSelect", 
                            "method"=>"post", 
                            "action"=>"modifydnsrecord.php?cust=".$cust)));
insert($f2,textbrbr(my_("Domain")));
insert($f2,block("<SELECT NAME='domain' ONCHANGE='submit()'>"."\n"));
$cnt=0;
while($row = $result->FetchRow()) {
   $data=$row["domain"];
   $cnt++;
   // set domain to first record if domain has not been selected prviously
   if ($cnt==1 and empty($domain)) {
        $domain=$data;
   }
   // save data_id for later for the "Add" button
   if ($data==$domain) {
       $zoneid=$row["data_id"];
       insert($f2,block("<OPTION VALUE= '".$data."' SELECTED>".$data."\n"));
   }
   else {
       insert($f2,block("<OPTION VALUE= '".$data."'>".$data."\n"));
   }
} 
insert($f2,block("</SELECT>\n"));
insert($f2,generic("br"));
//insert($f2,submit(array("value"=>my_("Select Domain"))));

// Now Setup Page...
// get info from base table

if ($domain) {
    /*
       $result = &$ds->ds->Execute("SELECT data_id FROM fwdzone
       WHERE customer=$cust AND domain='$domain'");
       $row = $result->FetchRow();
       $zoneid=$row["data_id"];
     */

    $result = &$ds->ds->Execute("SELECT *
            FROM fwdzonerec
            WHERE customer=$cust AND data_id=$zoneid
            ORDER by sortorder");
}

$totcnt=0;
// fastforward till first record if not first block of data
while ($block and $totcnt < $block*MAXTABLESIZE and
       $row = $result->FetchRow()) {
    DisplayTextBlock($w, $row, $totcnt, "&domain=".$domain, $row["sortorder"]." - ".$row["host"] );
    $totcnt++;
}
insert($w,block("<p>"));
insert($w,textb($domain));

// create a table
insert($w,$tbig = table(array("cols"=>"1", "bgcolor"=>"#00CCFF")));
insert($tbig,$c = cell());
insert($c,$t = table(array("cols"=>"5",
                           "cellspacing"=>"1",
                           "bgcolor"=>"#99CCFF")));
// draw heading

insert($t,$c = cell());
insert($c,textb(my_("Sort-Order")));
insert($t,$c = cell());
insert($c,textb(my_("Host")));
insert($t,$c = cell());
insert($c,textb(my_("Record Type")));
insert($t,$c = cell());
insert($c,textb(my_("IP/Hostname")));
insert($t,$c = cell());
insert($c,textb(my_("Action")));


$cnt=0;
while($row = $result->FetchRow()) {
setdefault("cell",array("bgcolor"=>color_flip_flop()));

    $temphost=$row["host"];
    $tempiphostname=$row["ip_hostname"];

    if ($row["recordtype"]=="MX") {
        $tempiphostname=$temphost . " " . $tempiphostname;
        $temphost="";
    }
    if ($row["recordtype"]=="@") {
        $temphost="";
    }
    insert($t,$c = cell());
    insert($c,text($row["sortorder"]));

    insert($t,$c = cell());
    insert($c,text($temphost));

    insert($t,$c = cell());
    insert($c,text($row["recordtype"]));

    insert($t,$c = cell());
    insert($c,text($tempiphostname));

    insert($t,$c = cell());
    insert($c,block("<small>"));
    insert($c,anchor($PHP_SELF."?cust=$cust&dataid=".$row["recidx"]."&action=delete&domain=".$domain, my_("Delete Record"),
                $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
    insert($c,block(" | "));
    insert($c,anchor("modifydnsrecordform.php?cust=$cust&dataid=".$row["recidx"].
                "&action=edit".
                "&domain=".$domain.
                "&sortorder=".$row["sortorder"].
                "&host=".$row["host"].
                "&recordtype=".$row["recordtype"].
                "&iphostname=".$row["ip_hostname"], my_("Edit Record")));
    insert($c,block("</small>"));
    $cnt++;
    $totcnt++;
    if ($totcnt % MAXTABLESIZE == MAXTABLESIZE-1)
        break;
}

insert($w,block("<p>"));
while ($row = $result->FetchRow()) {
    $totcnt++;
    DisplayTextBlock($w, $row, $totcnt, "&domain=".$domain, $row["sortorder"]." - ".$row["host"] );
}

if ($domain) {
   insert($w, $f = form(array("method"=>"post", "action"=>"modifydnsrecordform.php?cust=$cust&action=add&domain=".$domain."&zoneid=".$zoneid)));
   insert($f,submit(array("value"=>my_("Add a Host"))));
}

if (!$cnt) {
   myError($w, my_("No Records found.  Please choose a domain and try again."));
}
   
$result->Close();
printhtml($w);

?>
