<?php

// IPplan v4.04
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

require_once("../class.templib.php");

if (!ANONYMOUS) {
   $auth = new SQLAuthenticator(REALM, REALMERROR);

   // And now perform the authentication
   $auth->authenticate();
}

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Modify IP address details");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
$ip=floor($ip);
$baseindex=floor($baseindex);
$block=(int)$block;
$updatedescrip=(int)$updatedescrip;
$ind=(int)$ind;
$action=(string)$action;
if (!$HTTP_GET_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

// make sure subnetsize is available
$result=$ds->GetBaseFromIndex($baseindex);
$row = $result->FetchRow();
$subnetsize=$row["subnetsize"];
$netdescrip=$row["descrip"];
$baseaddr=$row["baseaddr"];

// already have ip address to modify
if ($ip) {
   $iptemp=inet_ntoa($ip);

   // query could return nothing which is OK
   $result=&$ds->ds->Execute("SELECT userinf, location, telno, ipaddr, descrip, hname
                              FROM ipaddr
                              WHERE ipaddr=$ip AND baseindex=$baseindex");

   $row = $result->FetchRow();

   $result=&$ds->ds->Execute("SELECT info, infobin
                              FROM ipaddradd
                              WHERE ipaddr=$ip AND baseindex=$baseindex");

   $rowadd = $result->FetchRow();
}
// find next free address to modify
else {
   // order is important here!
   $result=&$ds->ds->Execute("SELECT ipaddr
                             FROM ipaddr
                             WHERE baseindex=$baseindex
                             ORDER BY ipaddr");

   $cnt=0;
   while($row = $result->FetchRow()) {
      // protect against network and broadcast address potentially
      // existing in database
      if ($row["ipaddr"] > $baseaddr and 
            $row["ipaddr"] < $baseaddr+$subnetsize-1)
         $arr[$cnt++]=$row["ipaddr"];
   }

   $cnt=0;
   for ($i=$baseaddr+1; $i < $baseaddr+$subnetsize-1; $i++) {
      if ($arr[$cnt] == $i)
         $cnt++;
      else
         break;
   }
   $ip=$i;
   $iptemp=inet_ntoa($ip);

   if ($ip==$baseaddr+$subnetsize-1)
      myError($w, my_("There are no available addresses"));
}

// initialize $files array now as can be used by uploaded file section
// required later to draw table of uploaded files too
$files=unserialize($rowadd["infobin"]);
            
// file uploaded
if ($action=="fileupload") {

    if (empty($HTTP_POST_FILES)) {
        $tmp=get_cfg_var("file_uploads");
        if (empty($tmp)) {
            insert($w,textB(my_("File uploads may have been disabled in the php.ini configuration file")));
            insert($w,block("<b>"));
        }
    }
    else {
        if ($HTTP_POST_FILES['userfile']['size'] == 0) {
            myError($w, sprintf(my_("Possible file size exceeded php.ini or webserver limit of %s - break file into smaller parts"), MAXUPLOADSIZE));
        }
        if (!is_uploaded_file($HTTP_POST_FILES['userfile']['tmp_name'])) {
            myError($w, my_("Possible file upload attack"));
        }
    }
    $filename = $HTTP_POST_FILES['userfile']['tmp_name'];

    if (empty($descrip)) {
            insert($w,text(my_("Filename must have a description - uploaded aborted"),
                      array("color"=>"#FF0000")));
            insert($w,textbr());
    }
    else {

        $files[] = array("name"=>$HTTP_POST_FILES['userfile']['name'],
                "size"=>$HTTP_POST_FILES['userfile']['size'],
                "date"=>date("F j, Y, g:i a"),
                "descrip"=>$descrip,
                "tmp_name"=>basename($HTTP_POST_FILES['userfile']['tmp_name']));

        $res=@move_uploaded_file($filename, UPLOADDIRECTORY."/".basename($filename));

        if ($res==TRUE) {
            $ds->DbfTransactionStart();

            // add serialized info from file upload
            $ds->ds->Execute("UPDATE ipaddradd
                    SET infobin=".$ds->ds->qstr(serialize($files))."
                    WHERE baseindex=$baseindex AND
                    ipaddr=$ip");
            // this generates a "duplicate key" error if no update
            // should be OK under normal circumstances, but generates error under
            // debug mode turned on
            if ($ds->ds->Affected_Rows() == 0) {
                $ds->ds->Execute("INSERT INTO ipaddradd
                        (infobin, baseindex, ipaddr)
                        VALUES
                        (".$ds->ds->qstr(serialize($files)).",
                         $baseindex,
                         $ip)");
            }
            $ds->AuditLog(sprintf(my_("User %s uploaded file %s ip %s"),
                        $HTTP_SERVER_VARS[AUTH_VAR],
                        $HTTP_POST_FILES['userfile']['name'], 
                        $iptemp));
            $ds->DbfTransactionEnd();

        }
        else {
            insert($w,text(my_("File could not be moved to upload location - upload failed probably due to directory permission problem"),
                      array("color"=>"#FF0000")));
            insert($w,textbr());
        }
    }
}
else if ($action=="filedelete") {
    $res=@unlink(UPLOADDIRECTORY."/".($files[$ind]["tmp_name"]));

    if ($res==TRUE) {
        $ds->DbfTransactionStart();

        $filename=$files[$ind]["name"];

        unset($files[$ind]);
        // last file deleted, clear array
        if (empty($files)) {
            unset($files);
        }

        // add serialized info after file deteled
        $ds->ds->Execute("UPDATE ipaddradd
                SET infobin=".$ds->ds->qstr(empty($files) ? "" : serialize($files))."
                WHERE baseindex=$baseindex AND
                ipaddr=$ip") and
            $ds->AuditLog(sprintf(my_("User %s deleted file %s ip %s"),
                        $HTTP_SERVER_VARS[AUTH_VAR], $filename, $iptemp));
        $ds->DbfTransactionEnd();

    }
    else {
            insert($w,text(my_("File could not be deleted - delete failed probably due to directory permission problem"),
                      array("color"=>"#FF0000")));
            insert($w,textbr());
    }

}
else if ($action=="filedownload") {

    if (is_readable(UPLOADDIRECTORY."/".($files[$ind]["tmp_name"]))) {
        // force file download due to bad mime type
        header("Content-Description: File Transfer");
        header("Content-Type: application/force-download");
        header("Content-Type: application/octet-stream");
        header("Content-Length: ".$files[$ind]["size"]);
        header("Content-Transfer-Encoding: binary");
        header("Content-Disposition: attachment; filename=".$files[$ind]["name"].";");

        readfile(UPLOADDIRECTORY."/".($files[$ind]["tmp_name"]));
        exit;
    }
    else {
        insert($w,text(my_("File could not be downloaded - download failed probably due to directory permission problem"),
                    array("color"=>"#FF0000")));
        insert($w,textbr());

    }
}

// save md5str for check in displaysubnet.php to see if info has
// been modified since start of edit
$md5str=$ds->GetMD5($ip, $baseindex);

insert($w,block("<h3>"));
insert($w,textbr(my_("Subnet:")." ".
                  inet_ntoa($baseaddr)." ".my_("Mask:")." ".
                  inet_ntoa(inet_aton(ALLNETS)+1 -
                    $subnetsize)."/".inet_bits($subnetsize)));
insert($w,text(my_("Description:")." ".$netdescrip));
insert($w,block("</h3>"));
insert($w,textbr());
insert($w,textB(my_("IP Address to modify:")." ".$iptemp));
if ($ipplanPoll and ScanHost($iptemp, 1))
   insert($w,text(my_(" (Address active on network) "),
             array("color"=>"#FF0000")));
insert($w,block(" | "));

/* broken
insert($w,anchor("whois.php?lookup=".$iptemp,
                  my_("Whois")));
insert($w,block(" | "));
*/
if (!ini_get("safe_mode")) {
   insert($w,anchor("ping.php?lookup=".$iptemp,
                     my_("Ping")));
   insert($w,block(" | "));
   insert($w,anchor("traceroute.php?lookup=".$iptemp,
                     my_("Traceroute")));
   insert($w,block(" | "));
}
insert($w,anchor("dns.php?ip=".$iptemp,
                  my_("DNS")));
insert($w,block(" | "));

insert($w,anchor("modifyipform.php?ip=".$ip.
                 "&baseindex=".$baseindex."&block=".$block.
                 "&updatedescrip=1",
                 my_("Update hostname from DNS")));

if (extension_loaded("snmp")) {
   insert($w,block(" | "));

   insert($w,anchor("modifyipform.php?ip=".$ip.
                    "&baseindex=".$baseindex."&block=".$block.
                    "&updatedescrip=2",
                    my_("Query device info via SNMP")));

}

insert($w,generic("br"));

// start form for modify
insert($w, $f = form(array("name"=>"MODIFY",
                           "method"=>"post",
                           "action"=>"displaysubnet.php")));

$userinf=$row["userinf"];
$location=$row["location"];
$descrip=$row["descrip"];
$hname=$row["hname"];
$telno=$row["telno"];
$dbfinfo=$rowadd["info"];

if ($updatedescrip==1) {
   $dnsdescrip=gethostbyaddr($iptemp);
   if ($dnsdescrip != $iptemp) {
       $hname=$dnsdescrip;
   }
} else if ($updatedescrip==2) {
   if ($userinf = substr(@snmpget($iptemp, "public", ".1.3.6.1.2.1.1.4.0"),8)) {
      // only query others if first query was a success
      $descrip = substr(@snmpget($iptemp, "public", ".1.3.6.1.2.1.1.1.0"),8);
      $hname = substr(@snmpget($iptemp, "public", ".1.3.6.1.2.1.1.5.0"),8);
      $location = substr(@snmpget($iptemp, "public", ".1.3.6.1.2.1.1.6.0"),8);
      // get the interface table while we are at it and check the subnet
      // mask - could be multiple interfaces on router
      // array contains ip address as key and mask as value
      $interfaces = snmpwalkoid($iptemp, "public", ".1.3.6.1.2.1.4.20.1.3");
      foreach($interfaces as $key => $value) {
         if (strstr($key, $iptemp)) {
            // found exact match of interface - compare mask
            if (!strstr($value, inet_ntoa(inet_aton(ALLNETS)+1 - $subnetsize))) {
               insert($f,textbr());
               insert($f,text(my_("The subnet mask configured on the device appears to be incorrect!"),
                   array("color"=>"#FF0000")));
               insert($f,textbr());
            }
            break;
         }
      }
   }
   else {
      // reset failed query to original value
      $userinf=$row["userinf"];
   }
}

insert($f,textbrbr(my_("User")));
insert($f,input_text(array("name"=>"user",
                           "value"=>$userinf,
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($f,textbrbr(my_("Location")));
insert($f,input_text(array("name"=>"location",
                           "value"=>$location,
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($f,textbrbr(my_("Device description")));
insert($f,input_text(array("name"=>"descrip",
                           "value"=>$descrip,
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($f,textbrbr(my_("Device hostname")));
insert($f,input_text(array("name"=>"hname",
                           "value"=>$hname,
                           "size"=>"80",
                           "maxlength"=>"100")));
insert($f,textbrbr(my_("Telephone number")));
insert($f,input_text(array("name"=>"telno",
                           "value"=>$telno,
                           "size"=>"15",
                           "maxlength"=>"15")));

// if a specific network template exists, use that, else use generic template
if (is_readable(dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME'])."/iptemplate-network.xml") and !TestBaseAddr($ip, $subnetsize)) {
    $template=new IPplanIPTemplate(dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME'])."/iptemplate-network.xml");
}
else {
    $template=new IPplanIPTemplate(dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME'])."/iptemplate.xml");
}
if ($template->is_error() == FALSE) {
    insert($f,block("<hr>"));
    insert($f,textbr(my_("Additional information"), array("b"=>1)));

    $template->Merge($template->decode($dbfinfo));
    $template->DisplayTemplate($f);
}

insert($f,hidden(array("name"=>"baseindex",
                      "value"=>"$baseindex")));
insert($f,hidden(array("name"=>"ip",
                      "value"=>"$ip")));
insert($f,hidden(array("name"=>"subnetsize",
                      "value"=>"$subnetsize")));
insert($f,hidden(array("name"=>"block",
                      "value"=>"$block")));
insert($f,hidden(array("name"=>"md5str",
                      "value"=>"$md5str")));

insert($f,generic("br"));
insert($f,submit(array("value"=>my_("Submit"))));
insert($f,freset(array("value"=>my_("Clear"))));

// start form for upload
insert($w, $f = form(array("method"=>"post",
                           "enctype"=>"multipart/form-data",
                           "action"=>"$PHP_SELF?baseindex=$baseindex&ip=$ip&block=$block")));

insert($f,block("<hr>"));
insert($f,textbr(my_("Upload files"), array("b"=>1)));
insert($f,block("<p>"));

// files have been uploaded previously - $files array has been initialize
// earlier
if (is_array($files)) {
        insert($f,$t = table(array("cols"=>"5",
                    "cellspacing"=>"1",
                    "bgcolor"=>"#99CCFF")));
        // draw heading
        insert($t,$c = cell());
        insert($c,textB(my_("Filename")));
        insert($t,$c = cell());
        insert($c,textB(my_("Description")));
        insert($t,$c = cell());
        insert($c,textB(my_("Size")));
        insert($t,$c = cell());
        insert($c,textB(my_("Date")));
        insert($t,$c = cell());
        insert($c,textB(my_("Action")));


        foreach($files as $key => $value) {
        setdefault("cell",array("bgcolor"=>color_flip_flop()));

            insert($t,$c = cell());
            insert($c,text($files[$key]["name"]));

            insert($t,$c = cell());
            insert($c,text($files[$key]["descrip"]));

            insert($t,$c = cell());
            insert($c,text($files[$key]["size"]));

            insert($t,$c = cell());
            insert($c,text($files[$key]["date"]));

            insert($t,$c = cell());
            insert($c,anchor("$PHP_SELF?baseindex=$baseindex&ip=$ip&block=$block&action=filedelete&ind=$key",
                        "<small>Delete file</small>"));
            insert($c,block(" | "));
            insert($c,anchor("$PHP_SELF?baseindex=$baseindex&ip=$ip&block=$block&action=filedownload&ind=$key",
                        "<small>Download file</small>"));


        }
}

insert($f,textbrbr(my_("Filename description")));
insert($f,input_text(array("name"=>"descrip",
                           "size"=>"80",
                           "maxlength"=>"80")));

insert($f,textbrbr(my_("File name")));
insert($f,hidden(array("name"=>"MAX_FILE_SIZE",
                       "value"=>MAXUPLOADSIZE)));
insert($f,inputfile(array("name"=>"userfile")));

insert($f,hidden(array("name"=>"action",
                      "value"=>"fileupload")));
insert($f,hidden(array("name"=>"md5str",
                      "value"=>"$md5str")));
insert($f,submit(array("value"=>my_("Upload file"))));

// start form for delete
// all info will be blank, thus record will be deleted
$settings=array("name"=>"DELETE",
                "method"=>"post",
                "action"=>"displaysubnet.php");
if ($ipplanParanoid)
   $settings["onsubmit"]="return confirm('".my_("Are you sure?")."')";
insert($w, $f = form($settings));

insert($f,block("<hr>"));

insert($f,hidden(array("name"=>"baseindex",
                      "value"=>"$baseindex")));
insert($f,hidden(array("name"=>"ip",
                      "value"=>"$ip")));
insert($f,hidden(array("name"=>"subnetsize",
                      "value"=>"$subnetsize")));
insert($f,hidden(array("name"=>"action",
                      "value"=>"delete")));
insert($f,hidden(array("name"=>"block",
                      "value"=>"$block")));
insert($f,hidden(array("name"=>"md5str",
                      "value"=>"$md5str")));

insert($f,submit(array("value"=>my_("Delete record"))));
insert($f,text(my_("WARNING: Deleting an entry does not preserve the last modified information as the record is completely removed from the database to conserve space.")));

if (is_array($files)) {
    insert($w,text(my_("Deleting this record will delete all associated uploaded files!"),
                array("color"=>"#FF0000")));
    insert($w,textbr());
}

printhtml($w);

?>
